# dicBrowseKeyword 
# dicBrowseClass 
# dicBrowseContext 
# dicBrowseComment 
# dicBrowseFormat
# dicBrowseUnit  
# dicBrowseDescriptionWdg

#Initialize the tool, set flags, etc.
proc htInitX {} {
    global gvar env cv 

    # Capture the window manager delete window action and override the
    # window manager's default action.
    #windowOnTop .ht
    set gvar(htCV)                   .ht.top.wdg.can
    set _top_level [winfo toplevel $gvar(htCV)]
    wm protocol $_top_level WM_DELETE_WINDOW "bell"
    
    #Trap signals
    signal trap {INT QUIT TERM} {htInfo "Please use Quit to exit from the application."}
    signal trap {CONT} "wm deiconify ."


    #Allow multiple selections of entries.
    set w $gvar(htCV).htTransTableWdg
    bind $w <Any-KeyPress> "htGroupSelListMode $w KeyPress"
    bind $w <Any-KeyRelease> "htGroupSelListMode $w KeyRelease"
    htGroupSelListMode $w KeyRelease
    bind $w.f1.uifFancyListBox <Control-a> "htSelectAll $w"

     
    $gvar(htCV).htTransTableWdg addItem 0 "Initializing ht ..."
    Busy $gvar(htCV) {
	
	#SOG. Remove this.
	#set gvar(tableItemList)  "Imaging"
	#set gvar(tableItemValue) "/diska/home/archeso3/asto/imaging.ht"
	
	#puts "Define constants"
	htConstants

	#I have to disable the Quit entry in the menu: there is a
	#problem with Panel Editor: the last entry executes a panClosePanel
	#Whatever entry, buto only if the panel has been loaded with panImportPanel
	#The workaround is to create the Quit entry anyway, but disable it...
	#An SPR will be opened.
	#If the Header Translator is executed stand alone, 
	#change name of the buttons.
	if {![info exists gvar(mainCV)]} {
	    htStandAlone
	} else {
	    panDisableMenuEntry File "Quit"
	}
	
	panDisableMenuEntry Edit "Undo Deletion"

	htDebug "Disable entries" 3
	htDisableEntries
	htDebug "Clear all dictionaries" 3 
	
	htClearAllDicOutput
		set gvar(newKeyFlag) 0
	if {![info exist env(INS_ROOT)]} {
	    htInfo "INS_ROOT not set"
	    exit }
	
	set gvar(dic)  $env(INS_ROOT)/SYSTEM/Dictionary/ALL
	htDebug "Set dictionaries" 3
	htSetDictionary $gvar(dic)
	htDebug "Set bindings" 3
	htBindings

	#If selected load a conversion table.
	if {$gvar(selTable) != "" } { 
	    if {[htLoad]} { set gvar(selTable) "" }
	}

	if {![info exists gvar(obsName)]} { set gvar(obsName) "undefined" }

	#Disable some menu entries.
	if {$gvar(selTable) == "" }  {
	    regsub " " $gvar(obsName) "_" gvar(selCleanTable)
	    $gvar(htCV).htSaveasButtWdg configure -label "Save As..."
	    panDisableMenuEntry File "Save"
	    $gvar(htCV).htTransTableWdg deleteItem 0 end
	    #addMethod
	}
	set gvar(oldTable) $gvar(selTable)
    }
}

#Disable all the entries
proc htDisableEntries {} {
    global gvar 

    $gvar(htCV).htFormatWdg disable
    $gvar(htCV).dicBrowseTypeWdg disableEntry 0 
    $gvar(htCV).dicBrowseTypeWdg disableEntry 1
    $gvar(htCV).dicBrowseTypeWdg disableEntry 2
    $gvar(htCV).dicBrowseTypeWdg disableEntry 3
    $gvar(htCV).dicBrowseTypeWdg disableEntry 4
    $gvar(htCV).htValueWdg disable
    $gvar(htCV).htCommentWdg disable
}

#Enable all the entries
proc htEnableEntries {} {
     global gvar 

    #$gvar(htCV).htFormatWdg enable
    $gvar(htCV).dicBrowseTypeWdg enableEntry 0 
    $gvar(htCV).dicBrowseTypeWdg enableEntry 1
    $gvar(htCV).dicBrowseTypeWdg enableEntry 2
    $gvar(htCV).dicBrowseTypeWdg enableEntry 3
    $gvar(htCV).dicBrowseTypeWdg enableEntry 4
    $gvar(htCV).htValueWdg   enable
    if {$gvar(dicBrowseType) == "double" ||
	$gvar(dicBrowseType) == "complex"} {
	$gvar(htCV).htFormatWdg  enable
    }
    $gvar(htCV).htCommentWdg enable
    set gvar(clearFlag) 0
}


#Clear the entries
proc htClearEntries {} {
    global gvar

    set gvar(dicBrowseFormat) ""
    set gvar(htValue) ""
    set gvar(htComment) ""
    
}

#Check the format of the keyword
proc checkFormat {format} {
    global gvar
    
    if {$format == "double" || $format == "complex" } {
	$gvar(htCV).htFormatWdg enable
	set gvar(dicBrowseFormat) ""
    } else {
	$gvar(htCV).htFormatWdg disable
    }
}

proc htLoadIrafTable {table} {
    global gvar env
    
    set gvar(irafTable) ""
    set gvar(keyView) ""
    set gvar(keyList) ""
    set gvar(irafNumKeys) 0
    set formatLine "%-30s %-20s"
    
    if {[catch {set load [open $table r]}]} {
	htInfo "I cannot open predefined translation table." 
	return 1
    }

    
    #Scan the predefined table and assign the proper keywords.
    
    set sc [scancontext create]
    
    # 0 COPY.SRCKEY
    # 1 COPY.SRCHDR
    # 2 COPY.TRGKEY 
    # 3 COPY.TRGHDR
    # 4 COPY.FCT
    # 5 DIC.KEY
    # 6 DIC.TYPE
    # 7 DIC.FORMAT
    # 8 DIC.COMMENT

    scanmatch $sc {^(COPY.SRCKEY)(["	"]+)(.*)$} {lappend sourceKey  $matchInfo(submatch2)}
    scanmatch $sc {^(COPY.SRCHDR)(["	"]+)(.*)$} {lappend sourceHdr  $matchInfo(submatch2)}
    scanmatch $sc {^(COPY.TRGKEY)(["	"]+)(.*)$} {lappend targetKey  $matchInfo(submatch2)}
    scanmatch $sc {^(COPY.TRGHDR)(["	"]+)(.*)$} {lappend targetHdr  $matchInfo(submatch2)}
    scanmatch $sc {^(COPY.FCT)(["	"]+)(.*)$} {lappend copyFct  $matchInfo(submatch2)}
    scanmatch $sc {^(COPY.FCT)$} {lappend copyFct "noFunction"}
    scanmatch $sc {^(DIC.KEY)(["	"]+)(.*)$} {lappend dicKey  $matchInfo(submatch2)}
    scanmatch $sc {^(DIC.TYPE)(["	"]+)(.*)$} {lappend dicType  $matchInfo(submatch2)}
    scanmatch $sc {^(DIC.FORMAT)(["	"]+)(.*)$} {
	lappend dicFormat  $matchInfo(submatch2)}
    scanmatch $sc {^(DIC.COMMENT)(["	"]+)(".*")$} {
	lappend dicComment  $matchInfo(submatch2)}
    
    scanfile $sc $load
    
    
    if {[catch {set lengthSource [llength $sourceKey]}]} {
	htInfo "Translation table:\n$table\nnot readable or corrupted"
	return 1
    }
    for {set i 0} {$i < $lengthSource} {incr i} {
	if {[catch {lappend gvar(keyList) "[lindex $sourceKey $i] [lindex $sourceHdr $i] [lindex $targetKey $i] [lindex $targetHdr $i] [lindex $copyFct $i] [lindex $dicKey $i] [lindex $dicType $i] [lindex $dicFormat $i] [lindex $dicComment $i]"}]} {
	    htInfo "Predefined table:\n$table\nnot readable or corrupted"
	    return 1
	}
    }
    
    #Set a vector containing the key to show.
    foreach element $gvar(keyList) {
	incr gvar(irafNumKeys)
	set tmpKeyView [eval format [concat \"$formatLine\" \
					 [lindex $element 2] \
					 [lindex $element 0]]]
	lappend gvar(keyView) $tmpKeyView 
    }
    
    set gvar(fileSaved) 0
    return 0
}

#Load a predefined table.
proc htLoad {} {
    global gvar 

     if {($gvar(fileSaved) == 0)} {
	
	set choice [tk_messageBox -type yesno -default yes \
		    -message "Table not saved.\nAre you sure you want\nto load a table ?" \
			-icon question \
			-title "Header Translator"]
	
	if {$choice == "no"} {
	    return
	} 
    }

    set gvar(selTable) [htSelectFile [pwd] *]
    if {[file tail $gvar(selTable)] == ""} { return 1}
    
    set gvar(keyView) ""
    set gvar(keyList) ""
    set keyBuffer ""
    set formatLine "%-30s %-20s"
    
    if {[catch {set load [open $gvar(selTable) r]}]} {
	htInfo "I cannot open $gvar(selTable)." 
	return 1
    }

    #Scan the whole file and fill a vector with keywords.
    set sc [scancontext create]
    
    # 0 COPY.SRCKEY
    # 1 COPY.SRCHDR
    # 2 COPY.TRGKEY 
    # 3 COPY.TRGHDR
    # 4 COPY.FCT
    # 5 DIC.KEY
    # 6 DIC.TYPE
    # 7 DIC.FORMAT
    # 8 DIC.COMMENT

    scanmatch $sc {^(COPY.SRCKEY)(["	"]+)(.*)$} {lappend sourceKey  $matchInfo(submatch2)}
    scanmatch $sc {^(COPY.SRCHDR)(["	"]+)(.*)$} {lappend sourceHdr  $matchInfo(submatch2)}
    scanmatch $sc {^(COPY.TRGKEY)(["	"]+)(.*)$} {lappend targetKey  $matchInfo(submatch2)}
    scanmatch $sc {^(COPY.TRGHDR)(["	"]+)(.*)$} {lappend targetHdr  $matchInfo(submatch2)}
    scanmatch $sc {^(COPY.FCT)(["	"]+)(.*)$} {lappend copyFct  $matchInfo(submatch2)}
    scanmatch $sc {^(COPY.FCT)$} {lappend copyFct "noFunction"}

    scanmatch $sc {^(ADD.KEY)(["	"]+)(.*)$} {
	if {$keyBuffer != ""} {
	    lappend sourceKey "-"
	    lappend sourceHdr 0
	    lappend targetKey $keyBuffer
	    lappend targetHdr 0
	    lappend copyFct "noFunction"
	    set keyBuffer ""

	    lappend sourceKey "-"
	    lappend sourceHdr 0
	    lappend targetKey $matchInfo(submatch2)
	    lappend targetHdr 0
	    lappend copyFct "noFunction"
	} else {
	    set keyBuffer $matchInfo(submatch2)
	}
    }

    scanmatch $sc {^(ADD.VALUE.KEY)(["	"]+)(.*)$} {
	lappend sourceKey $matchInfo(submatch2)
	lappend sourceHdr 0
	lappend targetKey $keyBuffer
	lappend targetHdr 0
	lappend copyFct "noFunction"
	set keyBuffer ""
    }

    scanmatch $sc {^(ADD.VALUE.CONST)(["	"]+)(.*)$} {
	lappend valueConst $matchInfo(submatch2)
    }

    scanmatch $sc {^(DIC.KEY)(["	"]+)(.*)$} {lappend dicKey  $matchInfo(submatch2)}
    scanmatch $sc {^(DIC.TYPE)(["	"]+)(.*)$} {lappend dicType  $matchInfo(submatch2)}
    scanmatch $sc {^(DIC.FORMAT)(["	"]+)(.*)$} {lappend dicFormat  $matchInfo(submatch2)}
    scanmatch $sc {^(DIC.COMMENT)(["	"]+)(".*")$} {lappend dicComment  $matchInfo(submatch2)}
	  
    scanfile $sc $load

    if {$keyBuffer != ""} {
	lappend sourceKey "-"
	lappend sourceHdr 0
	lappend targetKey $keyBuffer
	lappend targetHdr 0
	lappend copyFct "noFunction"
	set keyBuffer ""
    }

    if {[catch {set lengthSource [llength $sourceKey]}]} {
	htInfo "Translation table:\n$gvar(selTable)\nnot readable or corrupted"
	return 1
    }
    set incrConst 0
    for {set i 0} {$i < $lengthSource} {incr i} {
	if {[lindex $sourceKey $i] == "-"} {
	    if {[catch {lappend gvar(keyList) "[lindex $sourceKey $i] [lindex $sourceHdr $i] [lindex $targetKey $i] [lindex $targetHdr $i] [lindex $copyFct $i] [lindex $dicKey $i] [lindex $dicType $i] [lindex $dicFormat $i] [lindex $dicComment $i] [lindex $valueConst $incrConst]"}]} {
		htInfo "Translation table:\n$table\nnot readable or corrupted"
		return 1
	    }
	    incr incrConst
	} else {
	   if {[catch {lappend gvar(keyList) "[lindex $sourceKey $i] [lindex $sourceHdr $i] [lindex $targetKey $i] [lindex $targetHdr $i] [lindex $copyFct $i] [lindex $dicKey $i] [lindex $dicType $i] [lindex $dicFormat $i] [lindex $dicComment $i]"}]} {
		htInfo "Translation table:\n$table\nnot readable or corrupted"
		return 1
	   }
	}
    }
    
    foreach element $gvar(keyList) {
	set tmpKeyView [eval format [concat \"$formatLine\" \
					 [lindex $element 2] \
					 [lindex $element 0]]]
	lappend gvar(keyView) $tmpKeyView 
    }

    
    #Update the listbox.
    $gvar(htCV).htTransTableWdg deleteItem 0 end
    $gvar(htCV).htTransTableWdg addItemList 0 $gvar(keyView)
    
    set gvar(fileSaved) 1
    set gvar(selCleanTable) [file tail $gvar(selTable)]
    $gvar(htCV).htSaveasButtWdg configure -label "Save"
    panEnableMenuEntry File "Save"
    htClearAllDicOutput
    return 0
}

#Save a defined table.
proc htSave {} {
    global gvar  env
    
    if {$gvar(selTable) == ""  } {
	htSaveAs
	if {$gvar(selTable) == ""} { return }
    }
    
    set gvar(selTable) "$gvar(selTable)"
    if {[catch {set outFile [open $gvar(selTable) w]} var]} { 
	htInfo "Cannot open the selected file: $gvar(selTable)" 
	panEnableMenuEntry File "Save As..."
	panDisableMenuEntry File "Save"
	$gvar(htCV).htSaveasButtWdg configure -label "Save As..."
	set gvar(selTable) ""
	return }

    #0 COPY.SRCKEY
    #1 COPY.SRCHDR
    #2 COPY.TRGKEY
    #3 COPY.TRGHDR
    #4 COPY.FCT
    
    #5 DIC.KEY
    #6 DIC.TYPE
    #7 DIC.FORMAT
    #8 DIC.COMMENT

    #Create the translation table.

    htDebug "Table = $gvar(keyList)" 3
    puts $outFile "\#\#\#\#\#\#\# FTU  Conversion table \#\#\#\#\#\#\#\n"
    puts $outFile "\# Don't edit this file manually."
    puts $outFile "\# Use the Header Translator to create/edit conversion tables\n\n"
    foreach line $gvar(keyList) {
	lassign $line srcKey srcHdr trgKey trgHdr function dicKey dicType dicFormat dicComment
	if {[llength $line] == 10} {
	    #This is a new key
	    set keyValue [lindex $line 9]
	    
	    puts $outFile "\#Add a new keyword\n"
	    puts $outFile "ADD.KEY\t$trgKey"
	    puts $outFile "ADD.HDR\t$trgHdr"
	    puts $outFile "ADD.VALUE.CONST\t$keyValue"
	    puts $outFile "\n"
	    puts $outFile "DIC.KEY\t$dicKey"
	    puts $outFile "DIC.TYPE\t$dicType"
	    puts $outFile "DIC.FORMAT\t$dicFormat"
	    puts $outFile "DIC.COMMENT\t\"$dicComment\""
	    puts $outFile "\n"
	    puts $outFile "\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#"
	    puts $outFile "\n"
	} else {
	    if {$function == "noFunction"} {
		set function "" 
	    } else {
		set function "\t$function"
	    }
	    
	    #RA and DEC need a different treatment.
	    #There is no internal function to convert those 2 keys,
	    #thus I have to do it almost manually"
	   
	    if {$srcKey == "RA"} {
		puts $outFile "ADD.KEY\t$trgKey"
		puts $outFile "ADD.HDR\t$trgHdr"
		puts $outFile "ADD.VALUE.KEY\tRA"
		puts $outFile "# 3600 * 1/15"
		puts $outFile "ADD.VALUE.CONST\t240"
		puts $outFile "ADD.FCT\tMultiplyDouble"
		puts $outFile "CHANGE.KEY\t$trgKey"
		puts $outFile "CHANGE.HDR\t$trgHdr"
		puts $outFile "CHANGE.VALUE.KEY\t$trgKey"
		puts $outFile "CHANGE.FCT\tUt2IsoTime"
		puts $outFile "\n"
		puts $outFile "DIC.KEY\t$dicKey"
		puts $outFile "DIC.TYPE\tstring"
		puts $outFile "DIC.FORMAT\t%s"
		puts $outFile "DIC.COMMENT\t\"$dicComment\""
		puts $outFile "\n"
		puts $outFile "\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#"
		puts $outFile "\n"
	    } elseif {$srcKey == "DEC"} {
		puts $outFile "ADD.KEY\t$trgKey"
		puts $outFile "ADD.HDR\t$trgHdr"
		puts $outFile "ADD.VALUE.KEY\tDEC"
		puts $outFile "# * 3600"
		puts $outFile "ADD.VALUE.CONST\t3600"
		puts $outFile "ADD.FCT\tMultiplyDouble"
		puts $outFile "CHANGE.KEY\t$trgKey"
		puts $outFile "CHANGE.HDR\t$trgHdr"
		puts $outFile "CHANGE.VALUE.KEY\t$trgKey"
		puts $outFile "CHANGE.FCT\tUt2IsoTime"	
		puts $outFile "\n"
		puts $outFile "DIC.KEY\t$dicKey"
		puts $outFile "DIC.TYPE\tstring"
		puts $outFile "DIC.FORMAT\t%s"
		puts $outFile "DIC.COMMENT\t\"$dicComment\""
		puts $outFile "\n"
		puts $outFile "\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#"
		puts $outFile "\n"
	    } else {
		puts $outFile "\#Copy a keyword\n"
		puts $outFile "COPY.SRCKEY\t$srcKey"
		puts $outFile "COPY.SRCHDR\t$srcHdr"
		puts $outFile "COPY.TRGKEY\t$trgKey"
		puts $outFile "COPY.TRGHDR\t$trgHdr"
		puts $outFile "COPY.FCT$function"
		puts $outFile "\n"
		puts $outFile "DIC.KEY\t$dicKey"
		puts $outFile "DIC.TYPE\t$dicType"
		puts $outFile "DIC.FORMAT\t$dicFormat"
		puts $outFile "DIC.COMMENT\t\"$dicComment\""
		puts $outFile "\n"
		puts $outFile "\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#"
		puts $outFile "\n"
	    }
	}
    }
    close $outFile
    set gvar(fileSaved) 1
}

#Save a defined table giving the name.
proc htSaveAs {} {
    global gvar env 

    set gvar(selTable) [htSelectFile [pwd] *]
    if {$gvar(selTable) == ""} { return }
    set gvar(selCleanTable) [file tail $gvar(selTable)]
    $gvar(htCV).htSaveasButtWdg configure -label "Save"
    panEnableMenuEntry File "Save"
    htSave
}

#Create a new translation table. Reset all the fields.
proc htNewTable {} {
    global gvar 
    
    if {($gvar(fileSaved) == 0)} {
	
	set choice [tk_messageBox -type yesno -default yes \
		    -message "Table not saved.\nAre you sure you want\na new table ?" \
			-icon question \
			-title "Header Translator"]
	
	if {$choice == "no"} {
	    return
	} 
    }
    set gvar(selTable) ""
    set gvar(selCleanTable) "<undefined>"
    $gvar(htCV).htSaveasButtWdg configure -label "Save As..."
    panDisableMenuEntry File "Save"
    panEnableMenuEntry File "Save As..."
    set gvar(keyList) ""
    set gvar(keyView) ""
    set gvar(fileSaved)  1
    addMethod $gvar(htOptTable)
}

#Close the panel. Check if the table was saved, before.
proc htQuit {} {
    global gvar  popflag env

    if {$gvar(fileSaved) == 0} {
	set choice [tk_messageBox -type yesnocancel -default yes \
		       -message "Table not saved.\n Can I save it as $env(HOME)/$gvar(selCleanTable) ?\n(If you press \"no\" you\n loose the changes)" \
		       -icon question \
		       -title "Header Translator"]
	
	if {$choice == "yes"} {
	    set gvar(selTable) "$env(HOME)/$gvar(selCleanTable)"
	    htSave
	} elseif {$choice == "cancel"} {
	    return
	} else {
	    if {[info exists gvar(mainCV)]} {
		htCancel
	    }
	}
    }
    
    set pid $gvar(procID)
    if {[file exists "/tmp/htTestTable-$pid.ht"]} {file delete "/tmp/htTestTable-$pid.ht"}
    if {[file exists "/tmp/ht-$pid.out"]} {file delete "/tmp/ht-$pid.out"}
        
    #set gvar(selCleanTable) [file tail $gvar(selTable)]
    closePanel
}

#Close the panel without changes.
proc htCancel {} {
    global gvar
    
    set gvar(selTable) $gvar(oldTable)
    set gvar(selCleanTable) [file tail $gvar(selTable)]
    closePanel
}

#Simply close the panel. Called by htQuit and htCancel.
proc closePanel {} {
    global gvar

    #Remember to change this when you change panel name
    
    set appName [winfo interps]
    set gvar(dominoHtFlag) 0
    if {[string match *dataSubscriber* $appName] && [info exists gvar(dominoTrans)]} {
	if {$gvar(selCleanTable) == "" || $gvar(selCleanTable) == "<undefined>" } {
	    set gvar(dominoTrans) 0
	    set gvar(selCleanTable) ""
	    $gvar(prefsCV).selTableWdg disable
	    $gvar(prefsCV).dominoTransWdg2 disable
	    #$gvar(prefsCV).dominoPrefsCheckHt disable
	} else { 
	    dominoUpdateOptions
	    set gvar(dominoTrans) 1 
	    $gvar(prefsCV).dominoPrefsCheckHt enable }
	panClosePanel no .ht
	wm deiconify .dominoPrefs
    } else { panClosePanel }

}

#Check if the new keyword belongs to the dictionary.
proc htNewKeyCheck {newKey} {
    global gvar  env
    
    #If Eso Keyword is empty it means that we are 
    #introducing a new keyword
    if {$gvar(dicBrowseKeywordModif) == 1} {
	htDicBrowseUpdateKeyword
	set gvar(dicBrowseKeywordModif) 0
	update idletasks; update}
    
    if {$gvar(newKeyFlag) == 0 && $gvar(dicBrowseKeyword) != ""} {
	
	htDebug "I give the command: htDic -lookUpKeyword \"baseDic $gvar(dicBrowseKeyword)\"..." 3
	set res [htDic -lookUpKeyword "baseDic $gvar(dicBrowseKeyword) "]
	htDebug "...and get: $res" 3
	if {$res == -1} {
	    htInfo "New Keyword is not an ESO keyword" 
	    set gvar(htNewKey) ""
	    return 
	} else {
	    set gvar(newKeyFlag) 1
	    htUpdateDicOutput $res
	}	
    }

    if {[string compare $newKey "BACKSPACE"] == 0} { return }
    
    if {![string match {[A-Z]} $newKey] && ![string match {[0-9]} $newKey] && 
	![string match "MINUS" $newKey] && ![string match "UNDERSCORE" $newKey] } {if {$gvar(htNewKey) == "" } { 
	    after 15 "set gvar(htNewKey) {} "
	    set newKey ""
	} else { set newKey ""}
    }

    
    if {$newKey == "MINUS"} {set newKey "-"}
    if {$newKey == "UNDERSCORE" } {set newKey "_"}
    if {[string length $gvar(htNewKey)] == 8} {set newKey ""} 
    
    #Strange trick to evaluate the keyword while inserting.
    set tmpkey [string toupper $gvar(htNewKey)$newKey]
    update
    after 10 set gvar(htNewKey) $tmpkey	
    after 10 $gvar(htCV).dicBrowseKeywordWdg.uifEntry icursor end
  
    # Do we consider a modification every time we modify a key ?
    # set gvar(modifyFlag) 0
    
    if {$gvar(dicBrowseKeyword) == ""} {htEnableEntries
    } else { htDisableEntries 
	set gvar(htComment) "" }
    
    $gvar(htCV).htCommentWdg enable
}

#Takes care of the listbox and the selected keyword.
proc htSelectLine {} {
    global gvar 
    
    set numElement [$gvar(htCV).htTransTableWdg getIndex]
    set numList [$gvar(htCV).htTransTableWdg getSize]
    if {$numElement == "" || [llength $numElement] > 1 } { return }

    htDebug "The selected line (index) is: $numElement" 3
    set gvar(position) $numElement

    #When i select an entry in the list box, I take the fields
    #from gvar(keyList), but  gvar(dicBrowseKeyword), I take
    # it from gvar(keyView): I need to show the key with dots and
    #without HIERARCH ESO
    set line [lindex $gvar(keyList) $gvar(position)]
    set listboxLine [lindex $gvar(keyView) $gvar(position)]



    # 0 COPY.SRCKEY
    # 1 COPY.SRCHDR
    # 2 COPY.TRGKEY 
    # 3 COPY.TRGHDR
    # 4 COPY.FCT
    # 5 DIC.KEY
    # 6 DIC.TYPE
    # 7 DIC.FORMAT
    # 8 DIC.COMMENT
    
    set gvar(dicBrowseType)     [lindex $line 6]
    set gvar(dicBrowseKeyword)  [lindex $line 0]
    set gvar(htComment)         [lindex $line 8]
    set gvar(dicBrowseFormat)   [lindex $line 7]
    set gvar(htNewKey)          [lindex $line 2]
    if {[llength $line] == 10} {
	set gvar(htValue)          [lindex $line 9]
    }

    if {$gvar(dicBrowseType) == "double"} {
	set gvar(dicBrowseFormat) [string trimright [string trimleft $gvar(dicBrowseFormat) "%"] "lf"]
    }

    if {$gvar(dicBrowseKeyword) == "" || $gvar(dicBrowseKeyword) == "-"} {
	set gvar(dicBrowseKeyword) ""
        htEnableEntries
        htDicBrowseClearDescr
    } else {
	htDicBrowseUpdateKeyword
	set gvar(htValue) ""
        htDisableEntries
        #set gvar(dicBrowseFormat) [lindex $newlist end]
        $gvar(htCV).htCommentWdg enable
    }

    set gvar(modifyFlag) 1
}


#Check the consistency of the table and apply the changes.
proc htApply {} {
    global gvar  env

    set formatLine "%-30s %-20s"
    #Convert Type in a format readable by corrfits
	switch -- $gvar(dicBrowseType) {
	    "string"  {set Type S ; set format "%s"}
	    "double"  {set Type F ; set format "%$gvar(dicBrowseFormat)lf"}
	    "integer" {set Type I ; set format "%d"}
	    "logical" {set Type B ; set format "%c"}
	    "complex" {set Type C ; set format "%$gvar(dicBrowseFormat)lf %$gvar(dicBrowseFormat)lf"}
	    default {htInfo "Variable format not supported.\n You cannot modify this keyword." ; return }
	}

    if {$gvar(dicBrowseKeyword) == "UTC" ||
	$gvar(dicBrowseKeyword) == "LST"} {
	set function "Ut2IsoTime" 
    } else {
	set function "noFunction"
    }
    
    if {$gvar(dicBrowseKeyword) != "" && $gvar(dicBrowseKeyword) != "-"} {
	set res [htDic -lookUpKeyword "baseDic $gvar(dicBrowseKeyword)"]
	if {$res == -1} {htInfo "The Eso key you selected is not valid. Try again." ; return } 
	
	#set context [lindex [split $res ,] 3]
	#regsub -all {\.} $gvar(dicBrowseKeyword)  " " gvar(dicBrowseRealKeyword)
	#if {$context != "FITS"} { set gvar(dicBrowseRealKeyword) "HIERARCH ESO $gvar(dicBrowseRealKeyword)"}
    
	if {$gvar(htNewKey) == ""} {htInfo "New Keyword is missing."; return }
	if {$gvar(htNewKey) == "HTRENAME"} {htInfo "This new keyword is reserved" ; return } 
	if {[htDic -lookUpKeyword "baseDic $gvar(htNewKey)"] != -1} {htInfo "You cannot use an Eso Keyword as New Keyword."; return }
	if {[string match *i* $gvar(dicBrowseKeyword)]} {htInfo "You forgot to specify a parameter in the Eso Keyword" ; return }
	set format $gvar(dicBrowseFormat)
	
	#In the dictionary the boolean format is defined as T (?)
	#but we need to set the format with %c
	if {$format == "T"} {set format "%c"}

	#set oldKey $gvar(dicBrowseKeyword)
	#set newKey $gvar(htNewKey)

	if {$gvar(modifyFlag) == 0} {
	    
	    if {[lsearch $gvar(keyList) "* $gvar(htNewKey) *"] != -1 } { 
		htInfo "$gvar(htNewKey) already defined" ; return }
	    lappend gvar(keyList) "$gvar(dicBrowseKeyword) 0 $gvar(htNewKey) 0 $function $gvar(htNewKey)  $gvar(dicBrowseType)  $format \"$gvar(htComment)\""
	    lappend gvar(keyView) [eval format [concat \"$formatLine\" $gvar(htNewKey) \"$gvar(dicBrowseKeyword)\"]]
	} else {
	    set gvar(keyList) [lreplace  $gvar(keyList) $gvar(position) $gvar(position) "$gvar(dicBrowseKeyword) 0 $gvar(htNewKey) 0 $function $gvar(htNewKey)  $gvar(dicBrowseType)  $format \"$gvar(htComment)\""]
	    set gvar(keyView) [lreplace $gvar(keyView) $gvar(position) $gvar(position) [eval format [concat \"$formatLine\" $gvar(htNewKey) \"$gvar(dicBrowseKeyword)\"]]]
	}
    } else { 
	if {$gvar(htNewKey) == ""} {htInfo "Nothing to do"; return }
	if {[htDic -lookUpKeyword "baseDic $gvar(htNewKey)"] != -1} {htInfo "You cannot use an Eso Keyword as a New Keyword."; return }
	
	if { ($gvar(dicBrowseType) == "double" || $gvar(dicBrowseType) == "complex") && $gvar(dicBrowseFormat) == ""} {htInfo "Precision is missing"; return }
	if {($gvar(dicBrowseType) == "double" || $gvar(dicBrowseType) == "complex") && [regexp {^[0-9.]+$} $gvar(dicBrowseFormat) ] == 0} {htInfo "Precision must be a positive number"; return }
	if {($gvar(dicBrowseType) == "double" || $gvar(dicBrowseType) == "complex") && [regexp {^[0-9.]+$} $gvar(htValue) ] == 0} {
	    htInfo "ConstValue must be a number" 
	    return 
	}
	if {$gvar(dicBrowseType) == "integer" && [regexp {^[0-9]+$} $gvar(htValue) ] == 0} {htInfo "Value must be an integer"; return }
	
	if {$gvar(htValue) == ""} {htInfo "Value is missing"; return }
	
	#Comments are mandatory
	if {$gvar(htComment) == ""} {htInfo "Comment is missing"; return }
	set oldKey $gvar(htNewKey)
	set newKey $oldKey
	if {$gvar(modifyFlag) == 0} {
	    if {[lsearch $gvar(keyList) "* $gvar(htNewKey) *"] != -1 } {
		htInfo "$gvar(htNewKey) already defined" ; return }
	    lappend gvar(keyList) "\"\" 0 $gvar(htNewKey) 0 $function $gvar(htNewKey)  $gvar(dicBrowseType)  $format \"$gvar(htComment)\" \"$gvar(htValue)\""
	    lappend gvar(keyView) [eval format [concat \"$formatLine\" $gvar(htNewKey) $gvar(blanks)]]
	} else {
	    set gvar(keyList) [lreplace $gvar(keyList) $gvar(position) $gvar(position) "\"\" 0 $gvar(htNewKey) 0 $function $gvar(htNewKey)  $gvar(dicBrowseType)  $format \"$gvar(htComment)\" \"$gvar(htValue)\""]
	    
	    set gvar(keyView) [lreplace $gvar(keyView) $gvar(position) $gvar(position) [eval format [concat \"$formatLine\" $gvar(htNewKey) $gvar(blanks)]]]
	}
    }
    
    set gvar(newKeyFlag) 0
    set gvar(fileSaved)  0
    htClearAllDicOutput
    $gvar(htCV).htTransTableWdg deleteItem 0 end
    $gvar(htCV).htTransTableWdg addItemList 0 $gvar(keyView)
    showLast 
    #addMethod $gvar(htOptTable)
}



proc htDeleteIraf {} {
    global gvar 


    if {$gvar(irafNumKeys) == 0} { return }
    
    set gvar(keyList) [lreplace $gvar(keyList) 0 [expr {$gvar(irafNumKeys) -1}]]
    set gvar(keyView) [lreplace $gvar(keyView) 0 [expr {$gvar(irafNumKeys) -1}]]

    set gvar(modifyFlag)  0   
    set gvar(irafNumKeys) 0
    set gvar(fileSaved)   0
    
    # addMethod $gvar(htOptTable)
}





#Delete the selected entry.
proc htDeleteEntry {} {
    global gvar 

    set elements [$gvar(htCV).htTransTableWdg getIndex]
    set numList [$gvar(htCV).htTransTableWdg getSize]
    
    if {$elements == "" || $numList == 0} {
	htInfo "Nothing to delete" ; return }
   
    set gvar(undoDeletionKeyList) $gvar(keyList)
    set gvar(undoDeletionKeyView) $gvar(keyView)
    
    #Enables undo button.
    panEnableMenuEntry Edit "Undo Deletion"

    foreach numElement $elements {


    if {$numElement <= $gvar(irafNumKeys)} {
 	incr gvar(irafNumKeys) -1
    }

    set gvar(keyList) [lreplace $gvar(keyList) $numElement $numElement "<DELETED>"]
    set gvar(keyView) [lreplace $gvar(keyView) $numElement $numElement "<DELETED>"]    
}
    
    set index [lsearch $gvar(keyList) "<DELETED>"]
    while { $index != -1} {
	set gvar(keyList) [lreplace $gvar(keyList) $index $index]
	set index [lsearch $gvar(keyList) "<DELETED>"]
    }
    
    set index [lsearch $gvar(keyView) "<DELETED>"]
    while { $index != -1} {
	set gvar(keyView) [lreplace $gvar(keyView) $index $index]
	set index [lsearch $gvar(keyView) "<DELETED>"]
    }

    set gvar(modifyFlag) 0   
    set gvar(fileSaved)  0
    $gvar(htCV).htTransTableWdg deleteItem 0 end
    $gvar(htCV).htTransTableWdg addItemList 0 $gvar(keyView)
    #addMethod $gvar(htOptTable)
} 

proc htUndoDeletion {} {
    global gvar

    if {$gvar(undoDeletionKeyList) == "" || $gvar(undoDeletionKeyList) == ""} {
	#nothing to undo
	return 
    }	

    set gvar(keyList) $gvar(undoDeletionKeyList)
    set gvar(keyView) $gvar(undoDeletionKeyView)
    set gvar(undoDeletionKeyList) ""
    set gvar(undoDeletionKeyView) ""
    # disable undo button
    panDisableMenuEntry Edit "Undo Deletion"

    $gvar(htCV).htTransTableWdg deleteItem 0 end
    $gvar(htCV).htTransTableWdg addItemList 0 $gvar(keyView)
}

#Add a method by clicking the check button.
proc addMethod {table} {
    global gvar 

    htDeleteIraf
    set oldKeyList $gvar(keyList)
    set oldKeyView $gvar(keyView)
    

    #	set gvar(numMethodList) 1
    #Use this in case you need to show the complete list.
    #set gvar(numMethodList) [llength $gvar(irafKeyList)]
    if {$table != "NONE" } {
	htLoadIrafTable $table
	set gvar(keyList) [concat $gvar(keyList) $oldKeyList]
	set gvar(keyView) [concat $gvar(keyView) $oldKeyView]	}

    $gvar(htCV).htTransTableWdg deleteItem 0 end
    $gvar(htCV).htTransTableWdg addItemList 0 $gvar(keyView)
    set gvar(fileSaved) 0


}

#Procedure to test a table, providing a fits file.
proc htTestTable {} {
    global gvar  env

    set oldSelectedTable $gvar(selTable)
    set oldSaveFlag $gvar(fileSaved)
    set pid $gvar(procID)
    set gvar(selTable) "/tmp/htTestTable-$pid"
    htDebug "Test table $gvar(selTable)" 1
    htSave
   
    set gvar(fitsSelected) [htSelectFile $env(DFS_GUI_CONFIG) *.fits]
    #puts "Test table on file: $gvar(fitsSelected)"
    
    if {$gvar(fitsSelected) == "" || [file isfile $gvar(fitsSelected)] == 0} {
	htInfo "No test performed." 
	return 
    }
    
    if {[file exists /tmp/ht-$pid.out]} {
	if {[catch {file delete /tmp/ht-$pid.out} var ]} {
	    htInfo "I cannot remove /tmp/ht-$pid.out. Please Check"
	    return
	}
    }

    #puts "execute: fitsTranslate -force -noStat -tolerant -overwrite  -targetDir /tmp -targetFile ht-$pid.out -ftt $gvar(selTable) -logFile /tmp/fitsTranslateLog.ht $gvar(fitsSelected)"
    
    htDebug "execute: fitsTranslate -force -noStat -tolerant -overwrite  -targetDir /tmp -targetFile ht-$pid.out -ftt $gvar(selTable) -logFile /tmp/fitsTranslateLog.ht $gvar(fitsSelected)" 1
    set result [catch {exec fitsTranslate -force -noStat -tolerant -overwrite  -targetDir /tmp -targetFile ht-$pid.out -ftt $gvar(selTable) -logFile /tmp/fitsTranslateLog.ht $gvar(fitsSelected)}]

    #puts "Showing Header for FITS File: \"output.file\""
    #puts "Result of fitsTranslate= $result"
    
    htDebug "Showing Header for FITS File: \"output.file\"" 1
    htDebug "Result of fitsTranslate= $result" 1
    
    set gvar(fileHeader) "Header of file: output.file"
    if {[catch {set fd [open "/tmp/ht-$pid.out" r]} var]} {
	htInfo "I cannot open /tmp/ht-$pid.out Please check:\n$var"
	return}
    set gvar(headerBuf) ""
    set run 1
    while {$run} {
	set hdBuf [read $fd 2880]
	if {$hdBuf != ""} {
	    set a 0
	    set b 79
	    set index 0
	    set line "start-val"
	    while {![string match END* $line] && ($line != "")} {
		set line [string range $hdBuf $a $b]
		if {($line != "") && \
			([string compare \
			      [string range $line 0 0] " "] != 0)} {
		    lappend gvar(headerBuf)  "${line}\n"
		}
		incr a +80
		incr b +80
		incr index
	    }
	    if {[string match END* $line]} {
		set run 0
	    }
	} else {
	    set run 0
	}
    }
    htDebug "Converted header = $gvar(headerBuf)" 1
    #panTerm "Fits Header" $buf
    panImportPanel htHeaderViewer
    set gvar(selTable) $oldSelectedTable
    set gvar(fileSaved) $oldSaveFlag

    .htHeaderViewer.top.wdg.can.htHeaderViewerWdg deleteItem 0 end
    .htHeaderViewer.top.wdg.can.htHeaderViewerWdg addItemList 0 $gvar(headerBuf)


    htDebug "Delete temporary header files" 3
    if {[catch {file delete "/tmp/htTestTable-$pid.ht"} var]} {
	htInfo "I cannot delete /tmp/htTestTable-$pid.ht \nPlease check and do it manually"}
}

#Procedure used to control the Eso key entry.
proc htDicBrowseUpdateKeyword {} {
    global gvar env 

    #I'm using an Eso Keyword, I disable the entries and clear the
    #variables
    if {$gvar(dicBrowseKeyword) == "NONE"} {
	htClearAllDicOutput
	return }
    htDisableEntries

    Busy $gvar(htCV) {
	set tmpKey [string toupper $gvar(dicBrowseKeyword)]
	set result [htGetList $tmpKey]
    }
    
    if {$result == "5"} {
	update
	after 10 htClearAllDicOutput
	after 10 $gvar(htCV).dicBrowseKeywordWdg.uifEntry icursor end
    }
}

#Provides the list of dictionary keywords, based on the entry field.
proc htGetList {tmpKey} {
    global gvar env 

    htDebug "Key press in Dicbrowser entry field: $tmpKey" 3
    #set tmpKey [string toupper $tmpKey]
    # Get a key match list from OSLX Dictionary
    #htClearDicOutput

    set res [htDic -lookUpKeyword "baseDic $tmpKey"]
    if {$res != -1 } {
	set keyList ""
	htUpdateDicOutput $res
	after 10 set gvar(dicBrowseKeyword) $tmpKey
    } else {
	set res [htDic -matchKey "baseDic $tmpKey"]
    set keyList [split $res ,]
    set noOfKeys [lindex $keyList 0]
    if {$noOfKeys == 0} {
	set leng [string length $tmpKey]
		set tmpKey [string range $tmpKey 0 [expr {$leng -2}]]
	if {$tmpKey == ""} { return 5
	} else {
	    after 10 set gvar(dicBrowseKeyword) $tmpKey
	    htGetList $tmpKey }
    } elseif {$noOfKeys > 1} {
	# Update the list of keys in the list box + enable binding
	# for selecting a key with the mouse
	htDicBrowseClearDescr
	for {set i 1} {$i <= $noOfKeys} {incr i} {
	    set keyword [lindex $keyList $i]
	    set class [lindex [split [htDic -lookUpKeyword "baseDic $keyword"] ","] 2]
	    if {[string match "*header*" $class]} {set keyArray($i) $keyword}
	    
	}
	$gvar(htCV).dicBrowseDescriptionWdg updateList keyArray
	$gvar(htCV).dicBrowseDescriptionWdg  setBind <Button-1>  {after 100 htChooseSelectedKey}
	
	# Get the best fit
	set tmpKey [htBestFit $tmpKey]
	after 10 set gvar(dicBrowseKeyword) $tmpKey
    } elseif {$noOfKeys == 1} {
	# There is only one key matching - we take it
	set tmpKey [lindex $keyList 1]
	
	set res [htDic -lookUpKeyword "baseDic $tmpKey"]
	htUpdateDicOutput $res
	after 10 set gvar(dicBrowseKeyword) $tmpKey
    	}
    }    
    update
	
    after 10 $gvar(htCV).dicBrowseKeywordWdg.uifEntry icursor end
    return $keyList   

}

#Extract the key tha better matches the one in the entry field.
proc htBestFit {tmpKey} {
    global gvar
    
    # Get the best fit
    set res [htDic -getBestFit "baseDic"]
    htDebug "Best Fit = |$res|" 3
    set res [split $res ,]
    set bestFitHits [lindex $res 0]
    set bestFit [lindex $res 1]
    if {$bestFitHits == 1} {
	set res [htDic -lookUpKeyword "baseDic $bestFit"]
	htUpdateDicOutput $res
    } elseif {[string length $bestFit] > [string length $tmpKey]} {
	set tmpKey $bestFit
    }
    return $tmpKey
}


proc htChooseSelectedKey {} {
    global gvar env 

    
    if {![info exists gvar(dicBrowseDescription)] \
	    || $gvar(dicBrowseDescription) == "" } { return }
    set key $gvar(dicBrowseDescription)
    set res [htDic -lookUpKeyword "baseDic $key"]
    if {$res != -1} {
	set gvar(dicBrowseKeyword) $key
    }
    htUpdateDicOutput $res 
}

#Clear part of the entry fields
proc htClearDicOutput {} {
    global gvar env 

    set gvar(htNewKey)         ""
    set gvar(dicBrowseType)    "string"
    set gvar(dicBrowseFormat)  ""
    set gvar(htValue)          ""
    set gvar(htComment)        ""
    set gvar(modifyFlag)       0
    #set gvar(actionFrame_dicBrowseUnit)    ""
    #set gvar(actionFrame_dicBrowseComment) ""
}

#Clear all the entry fields
proc htClearAllDicOutput {} {
    global gvar env 
    
    htClearDicOutput
    set gvar(dicBrowseKeyword) ""
    htDicBrowseClearDescr
}
    
#Complete a dictionary keyword, choosing the best fit.
proc htUpdateDicOutput {keyInfo} {
    global gvar env 

    # Delete binding on the Description Widget for selecting keyword
    # with the mouse
    
    # 8,DET.DIT,header|setup,Detector,double,%.4f,seconds,
    # Defined integration time,<undefined>
    set infoList [split $keyInfo ,]
    set index 2
    set class [lindex $infoList 2]
    if {[string compare $class "<undefined>"] != 0} {
	set gvar(dicBrowseClass)   $class
    }
    
    set gvar(dicBrowseType)    [lindex $infoList 4]
    set gvar(dicBrowseFormat)  [lindex $infoList 5]
    set unit [lindex $infoList 6]
    
    #Add the comment
    set gvar(htComment) [lindex $infoList 7]

    # For the description we have to find the 8th comma and copy out the
    # rest of the Keyword Info
    set index 0
    set description $keyInfo
    for {set i 0} {$i < 8} {incr i} {
	set index [string first "," $description]
	if {$index == -1} {
	    set description \
		    "Problem in the format of the Keyword Information!"
	    break;		    
	}
	incr index	
	set description [string range $description $index end]
    }

    set split [split $description "\n"]
    set description ""
    
    foreach textLine $split {
	append description [string trimleft $textLine " \t"]\n
    }


    if {[string compare $description "<undefined>"] == 0} {
	htDicBrowseClearDescr
    } else {
	set w $gvar(htCV).dicBrowseDescriptionWdg
	htDicBrowseClearDescr
	htUpdateTextListBox $w $description
    }
    $gvar(htCV).dicBrowseKeywordWdg.uifEntry icursor end   
}

#Refresh the list box.
proc htUpdateTextListBox {wdg text} {
    global gvar env 

    set textList [split $text "\n"]
    foreach line $textList {
	set line "${line}"
	$wdg addItem end $line
    }
}

#Clear the list box.
proc  htDicBrowseClearDescr {} {
    global gvar env 

    $gvar(htCV).dicBrowseDescriptionWdg deleteItem 0 end
}


# Procedure used to send commands to OSLX
proc htCmd {cmd par {data ""} {complain complain}} {
    global gvar env 
    global OSLX oslx

    htDebug "Executing OSLX Command: $cmd $par $data" 1
    
    # Decide whether to use the external OSLX Server or the OSLX Shell in the
    # Seq Wish
    if {$gvar(useSeqOslxCmd)} {
	update 
	update idletask
	if {[catch {seq_oslxCmd $cmd $par [lindex $data 0] \
		[lrange $data 1 end]} res]} {
	    if {$gvar(useCCS)} {
		set error [seq_errGetFromStack 1]
	    } else {
		set error $res
	    }
	    if {$complain == "-complain"} {
		htInfo "Error:\n\n\
			$error\n\n\
			Operation aborted!"	
	    }
	    return -1
	}

    } else {
	if {![info exists gvar(htCmdInitialized)]} {
	    oslxBASE  OSLX
	    set gvar(htCmdInitialized) 1
	}
	
	set res [OSLX SendMsg $cmd $par $data]
	if {$res > 0} {
	    htDebug "Result of command: $res" 1
	}
	if {$res == -1} {
	    htDebug "Error: $oslx(errorStack)" 1
	    set index [string first ":" $oslx(errorStack)]
	    if {$index != -1} {
		incr index
		set error [string trim \
			[string range $oslx(errorStack) $index end] "\""]
	    }
	    if {$complain == "-complain"} {
		htInfo "Error:\n\n\
			$error\n\n\
			Operation aborted!"
	    }
	    return -1
	}
    }

    if {$res > 0} {
	htDebug "Result of command: $res" 1
    }

    return $res
}

#Send oslx commands related to dictionaries.
proc htDic {par {data ""} {complain complain}} {
    global gvar

    if {$par == "-getBestFit"} {
 	set myKey $gvar(dicBrowseKeyword)
	set lengKey [string length $myKey]
    } else { set myKey [lindex $data 1]}

    regsub -all {[0-9]+} $myKey "i" tmpKey
    set lengKey [string length $tmpKey]
    set res [htCmd DICTION $par $data $complain]
    set keyList [split $res ,]
    set noOfKeys [lindex $keyList 0]
    if {$noOfKeys != 0 && [string match *i* $keyList ] && $res != -1} {
		set str2change [string range [lindex $keyList 1] 0 [expr {$lengKey -1}]]
	regsub -all $str2change $keyList $myKey result
	set res [join $result ","]
    }
    
    return $res
}

#Debug procedure, it shows internal messages
proc htDebug {text level} {
    global gvar

    if {![info exists gvar(debugMode)]} { return }
    if { $gvar(debugMode) <  $level } { return }
    set date [clock format [clock seconds] -format "%Y-%m-%d %T"]

    if {[info exists gvar(logFile)]} {puts $gvar(logFile) "Debug>\[$date\] $text"
    } else { puts "Debug>\[$date\] $text" }
}

proc Debug {txt} {
    global gvar

    if {![info exists gvar(HtVerbose)]} {
	set gvar(HtVerbose) 0
    }
	if {$gvar(HtVerbose)} {
	puts "HT> $txt ( verbose = $gvar(HtVerbose))"
    }
}

#Define all the bindings of the tool.
proc htBindings {} {
    global gvar env

    bind $gvar(htCV).dicBrowseKeywordWdg.uifEntry <Return> \
	    {htDicBrowseUpdateKeyword}
    bind $gvar(htCV).dicBrowseKeywordWdg.uifEntry \
	    <Control-Key-c> {htClearAllDicOutput}
    bind $gvar(htCV).dicBrowseKeywordWdg.uifEntry <Any-KeyPress> \
	{set gvar(dicBrowseKeywordModif) 1}
    $gvar(htCV).htTransTableWdg setBind <Button-1> {htSelectLine}
}

#Load the dicionaries.
proc htSetDictionary {dic} {
    global gvar
    

    update; update idletasks
    set dicName $dic
    if {[htGen -loadSetDicAll $dicName nocomplain] == -1} {
	    _htDicLoadProblem $dicName
    }
    if {[htDic -load "baseDic $dicName" nocomplain] == -1} {
	_htDicLoadProblem $dicName
    }

    htDebug "Loaded $dic" 1
}

#Interface to oslx General methods.
proc htGen {par {data ""} {complain complain}} {
    return [htCmd GEN $par $data $complain]
}

#Pop up info boxes.
proc htInfo {text} {
    #puts "htInfo> $text"
    tk_dialog .info "HT Dialog" $text info 0 OK
    htDebug $text 1
}

#Define constants and flags while initializing.
proc htConstants {} {
    global gvar env  seq_ccsType keyList keyView

    # Check first if the procedure was already called
    if {[info exists gvar(htConstantsExecuted)]} { 
	#puts "Already set"
	return }

    #puts "Bind..."
    bind $gvar(htCV).htNewKeyWdg.uifEntry <Any-KeyPress> {
	htNewKeyCheck [string toupper %K]
    }

    #Defaults Methods for corrfits (we enable all methods)
    
    #puts "Defaults Methods for corrfits (we enable all methods)"
    set gvar(htMethodStat)     1
    set gvar(htMethodAmbient)  1
    set gvar(htMethodSeeing)   1
    set gvar(htMethodSkyTrans) 1 
    set gvar(htMethodMoon)     1
    set gvar(keyList)               ""
    set gvar(keyView)               ""
    set gvar(irafNumKeys)      0
    set gvar(blanks)                "\"        \""
    set gvar(htHeaderTable)    [format "%-20s %-20s" "New Header" "Old Header"]
    set gvar(procID)           [pid]
    set gvar(irafHeaderStart)  "#PREDEFINED TRANSLATION TABLE START#"
    set gvar(irafHeaderEnd)    "#PREDEFINED TRANSLATION TABLE END#"

    # Some essential flags
    #puts "Some essential flags"
    set gvar(modifyFlag)             0
    set gvar(fileSaved)              1
    set gvar(clearFlag)              1
    set gvar(useSeqOslxCmd)          1
    set gvar(useCCS)                 0
    set gvar(logErrorsOnStderr)      0
    set gvar(dicBrowseKeywordModif)  1
    set gvar(numMethodList)          1
    if {![info exist gvar(selTable)]} {set  gvar(selTable)  ""}
    if {$gvar(useSeqOslxCmd)} {
	# When running without CCS we close stderr otherwise 
	# we have error logging on stderr (stdout)
	if {!$gvar(logErrorsOnStderr)} {
	    catch {close stderr}
	}
	#puts "package require SeqOslx"
	package require SeqOslx    
	if {$seq_ccsType == "none"} {
	    set gvar(useCCS)         0
	} else { 
	    set gvar(useCCS)         1
	}
    }

    # Initialize with CCS if requested
    if {$gvar(useCCS) && ![info exists gvar(ccsFd)]} {
	set gvar(ccsFd) [seq_ccsInit]
    }

    #puts "Init constants and some global variables"
    # Init constants and some global variables
    set gvar(msgTimeOut)             10000
    set gvar(htDIC_PREFIX)          ESO-VLT-DIC.
    set gvar(htALIAS_EXT)           .alias
    set gvar(htFITS_EXT)            .fits
    set gvar(actionFrame_fileFilter) "*"
    set gvar(headerFlag)             ""

    # Macros for File Types
    set gvar(htTYPE_ANY)            "ANY"
    set gvar(htTYPE_ALIAS_TAB)      "Alias Table"
    set gvar(htTYPE_CONFIG)         "Configuration File"
    set gvar(htTYPE_DIC)            "Dictionary"
    set gvar(htTYPE_FITS)           "FITS File"
    set gvar(htTYPE_INS_DIR)        "INS Tree"
    set gvar(htTYPE_OBS_BLOCK)      "Observation Block"
    set gvar(htTYPE_SETUP)          "Setup File"
    set gvar(htTYPE_TSF)            "TSF"
    set gvar(htTYPE_USER_FILE)      "User File"

    # Macros for Setup Files
    set gvar(htREF_SETUP)           0
    set gvar(htDET_SETUP)           1
    set gvar(htINS_SETUP)           2
    set gvar(htTEL_SETUP)           3
    set gvar(htALL_SETUP)           4
    
    set gvar(htREF_SETUP_EXT)       .ref
    set gvar(htDET_SETUP_EXT)       .det
    set gvar(htINS_SETUP_EXT)       .ins
    set gvar(htTEL_SETUP_EXT)       .targ

    set gvar(htPANEL_EXIT_OK)       1
    set gvar(htPANEL_EXIT_CANCEL)   2
    
    # Set default values for various variables
    set gvar(privMode)               0
    set gvar(htUserIconified)       1
    set gvar(htConstantsDefined)    1
    set gvar(rtdScale)               -1
    # Various addresses in the panel
    set gvar(fileControlFrame)     $gvar(htCV).fileControlFrame.frame
    set gvar(fileActionFrame)      $gvar(htCV).fileActionFrame.frame.actionFrame.cv
    set gvar(fileShortInfoFrame)   $gvar(htCV).fileShortInfoFrame.frame.fitsFileInfo.cv
    set gvar(fileShortInfoListWdg) \
	    $gvar(fileShortInfoFrame).quickInfoKeyWdg
    set gvar(fileMatchWdg)         $gvar(fileActionFrame).fileMatchList
    set gvar(htWorkingPointFrame)  $gvar(htCV).htWorkingPoint.frame.workingPoint.cv
    
    #Update the Table option button
    #puts "Update the Table option button"
    catch {$gvar(htCV).htSelTableWdg config -itemList  "NONE $gvar(tableItemList)"}
    catch {$gvar(htCV).htSelTableWdg config -itemValue "NONE $gvar(tableItemValue)"}
    set gvar(htHierarch) "NONE"
    set gvar(htOptTable) "NONE"
}

#Error messages related to dictionaries.
proc _htDicLoadProblem {dicName} {
    global gvar

    htInfo "ERROR: A problem occurred loading the Dictionary:\n\n\
	    \"$dicName\"\n\n\
	    When the FHT Preferences Editor appears, adjust the\
	    parameters:\n\n\
	    DEFAULT DICTIONARY: Set it to a specific Dictionary or\
	    to \"ALL\" if all Dictionaries in the INS Tree should be\
	    loaded at initialization.\n\n\
	    FHT HOME: If the INS Tree is not used the FHT Home should\
	    be specified. Normally this is: \"~/.fhtHome\". See the\
	    FHT documentation for further information about the FHT Home.\n\n\
	    USE INS TREE: If an INS Tree is available and it is desirable\
	    to use this switch this on, otherwise set this parameter\
	    to off. If the INS Tree is used the Dictionaries must be\
	    stored in\n\n\
	    \"\$INS_ROOT/SYSTEM/Dictionary\".\n\n\
	    DICTIONARY DIRECTORY: If the Dictionaries are located in\
	    a special directory the name of this directory must be\
	    given here (full path)."

}

#Pop up a window with 3 buttons (Yes Ok No).
proc htPopUp { mess1 yesflag okflag noflag } {
    global errorInfo popflag
    set w .htPopUp

    if {[winfo exists $w]} { destroy $w }

    set title  "Error Dialog"

    # Determine an estimate of the window width

    set len       [string length $mess1]
    set msgWidth  "8i"
    if {[set idx [string first "\n" $mess1]] != -1 } {
        set len $idx
    }

    if {$len > 36 } { set msgWidth "12i" }

    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w Dialog

    frame $w.top -relief raised -bd 1
    frame $w.bot -relief raised -bd 1

    pack $w.top            -fill both
    pack $w.bot            -expand yes -fill x

    
    #
    # Fill the top part with bitmap and message.
    #

	message $w.msg -width $msgWidth  -text $mess1 \
        -font -Adobe-Times-Medium-R-Normal-*-180-*
    pack $w.msg -in $w.top -side right -expand 1 -fill both -padx 5m -pady 5m

    #
    # Create a row of buttons at the bottom of the dialog.
    #
    frame $w.buttons -relief sunken -bd 1
    button $w.buttons.yes -text YES -command "set popflag 1"

    button $w.buttons.ok -text OK -command "set popflag 2"
    button $w.buttons.no -text NO -command "set popflag 0"
    pack append $w $w.buttons {top fill}

	pack append $w.buttons $w.buttons.yes   {left expand fillx padx 30} \
        $w.buttons.ok {left expand fillx padx 30} \
        $w.buttons.no {left expand fillx padx 30}
    

    if {$yesflag == 1} {$w.buttons.yes configure -state normal
    } else {$w.buttons.yes configure -state disabled}

    if {$okflag == 1} {$w.buttons.ok configure -state normal
    } else {$w.buttons.ok configure -state disabled}

    if {$noflag == 1} {$w.buttons.no configure -state normal
    } else {$w.buttons.no configure -state disabled}

    update idletasks

    # Set a grab and claim the focus too.

    set oldFocus [focus]
    grab $w ; focus $w


    # Set Geometry to allow the user to re-size only along X

    set geo    [wm geometry $w]
    scan $geo "%dx%d+%d+%d" wid hei posx posy

    wm minsize $w $wid $hei
    wm maxsize $w 1000 $hei
    #
    # Wait for the user to respond, then restore the focus and
    # return the index of the selected button.
    #

    tkwait variable popflag
    destroy $w
    return $popflag

}

proc htGroupSelListMode {w key} {

    if {$key == "KeyPress"} {
        $w configure -selectmode multiple
        $w setBind <Button-1> ""
    } else {
        $w configure -selectmode extended
    }
}

# Select all the entries
 proc htSelectAll {w} {
    
    $w setSelection ALL
}


#Change name of the buttons.
proc htStandAlone {} {
    global gvar 

    $gvar(htCV).ht-OkButtwdg config -label "Quit"
    destroy $gvar(htCV).ht-CancelButtwdg
}

#Show the last lines.
proc showLast {} {
    global gvar
    
    set l $gvar(htCV).htTransTableWdg
    set num [$l getSize]
    set pos [expr $num - 12]
    $l component uifFancyListBox yview $pos

}