#!/bin/sh
# Define which version of the sequencer to use \
  exec seqWish "$0"  ${1+"$@"}
#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: dataSubscriberAsto.pan,v 1.1 2004/09/06 14:47:14 cguirao Exp $" 
#
# dataSubscriberAsto.pan
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 4.25
#   date   : Fri Oct 22 18:28:33 METDST 1999
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------
#
global par gvar cv bcv actAreaHeight shArea panClassLib 
global geoCmdReply panClassLib panUsrProcs panUsrLib
global argv0 env panWidget panWidgetHlp panDbData cwp ckHeartBeat
global menu menuBar menuHelp ckMenuBar ckActBut ckShHelp ckCCS
# 
#  Get directory root of VLT, integration, current module. 
global VLTROOT INTROOT HOME

if {[catch {set VLTROOT $env(VLTROOT)}]} {set VLTROOT dummy}
if {[catch {set INTROOT $env(INTROOT)}]} {set INTROOT dummy}
if {[catch {set HOME    $env(HOME)}   ]} {set HOME    dummy}
# 
# Set auto_path 
# 

if { [file exist ../lib/libpanPublic.tcl] } { 
   lappend auto_path ../lib/libpanPublic.tcl
} elseif { [file exist $INTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $INTROOT/lib/libpanPublic.tcl
} elseif { [file exist $VLTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $VLTROOT/lib/libpanPublic.tcl 
} else {
   puts stderr "panel EXITS : Tcl library libpanPublic.tcl not found " 
   exit 1
}
set gvar(args) $argv

#
# Link panel to user libraries 
#
set panUsrLib   libdominoAstoLib  
set panClassLib {}

panSetAutoPath  $panUsrLib $panClassLib 

if {[info exists EDITING]} { 
   set panRoot .dataSubscriberAsto 
   set panUsrProcs {dataSubscriberAstoInit dataSubscriberAstoExit dataSubscriberAstoGlobalData dataSubscriberAstoInitData}
   set argc 0 ; set argv {}
} else {
   set par(MY_NAME) [file tail $argv0] 
   set EDITING 0
   set tk_strictMotif 0
   setPublicVar
   set panRoot . 
}

# User's Global Data 
# It contains definitions of constant data

proc dataSubscriberAstoGlobalData {} {

 # Declare any variable as global

   global gvar argc argv

 # Variable Initialization

 #Set here the color for the bitmaps
	
 set gvar(hotSpotCol) grey
}



# User's Init Data : called just after panInit
# It contains data to be defined before widgets are created

proc dataSubscriberAstoInitData {} {

 # Declare global variables

   global gvar

#return
set gvar(dominoFrom) ""
set gvar(dominoTo)   ""
setDominoAstoOptions
}



# User's Init Procedure : called in panMainStart
# It is executed after the widgets have been created

proc dataSubscriberAstoInit {} {

 # Declare global variables

   global gvar

 # User Initialization
#return
dominoInitX
}



#
#-----------------------------------------------
#            Widget Definition  
#-----------------------------------------------
# 

set ckHeartBeat   1 ;# Enable Heart-beat
set ckShHelp      0 ;# Set Short Help
set ckActBut      0 ;# Set Action Button Area
set ckMenuBar     1 ;# Setup Menu Bar
set ckCCS         0 ;# Initialize CCS
set ckCmdReply    0 ;# Display Cmd. Reply
set cwp           "" ;# Set Current Working Point
set actAreaHeight 5; # Set height of action area 

panReadOption winter
panCreateFrame dataSubscriberAsto ;# Create empty frame
panGetCvNames  dataSubscriberAsto cv bcv ;# Get Canvas Names
panInit        $argc $argv dataSubscriberAsto ;# Initialization



UifButton          $cv.dataSubscriberAsto-wdg1 -canvasAnchor nw  \
                  -command {dominoExCom fht} -initialState normal  \
                  -label {Start Fht} -popup 0  \
                  -stateVar gvar(dataSubscriberAsto-wdg4Var) -width 10 
UifOutput          $cv.dataSubscriberAsto-wdg2 -anchor e  \
                  -canvasAnchor nw -color Black  \
                  -font -Adobe-courier-bold-r-normal--24* -frame 0  \
                  -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*  \
                  -labelWidth 0 -variable gvar(filesQueued) -width 5 
UifOutput          $cv.dataSubscriberAsto-wdg3 -anchor e  \
                  -canvasAnchor nw -color Black  \
                  -font -Adobe-courier-bold-r-normal--24* -frame 0  \
                  -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*  \
                  -labelWidth 0 -variable gvar(filesProcessed) -width 5 
UifBarChart        $cv.dataSubscriberAstoBarchartWdg -axis 0  \
                  -canvasAnchor nw -length 180 -maxVal 100 -minVal 0  \
                  -orient h -ticks 0 -variable gvar(perc) 
UifButton          $cv.dominoConfigWdg -canvasAnchor nw  \
                  -command dominoEditPrefs -initialState normal  \
                  -label Config -popup 0  \
                  -stateVar gvar(dataSubscriberAsto-wdg10Var) -width 10 
UifBitmap          $cv.dominoNttWdg -canvasAnchor nw -frame raised  \
                  -hotSpot 0 -hotSpotColor Red 
UifButton          $cv.dominoShowLogWdg -canvasAnchor nw  \
                  -command showLog -initialState normal -label {Show Log}  \
                  -popup 0 -stateVar gvar(dataSubscriberAsto-wdg11Var)  \
                  -width 10 
UifButton          $cv.dominoStartWdg -canvasAnchor nw -command Start  \
                  -initialState normal -label {Start ADS} -popup 0  \
                  -stateVar gvar(dataSubscriberAsto-wdg2Var) -width 10 
UifButton          $cv.dominoStopWdg -canvasAnchor nw -command Stop  \
                  -initialState normal -label Stop -popup 0  \
                  -stateVar gvar(dataSubscriberAsto-wdg3Var) -width 10 
UifOutput          $cv.fromToWdg -anchor center -canvasAnchor nw  \
                  -color Black -font -Adobe-courier-medium-r-normal--12*  \
                  -frame 0  \
                  -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*  \
                  -labelWidth 0 -variable gvar(fromToLabel) -width 24 

#
#  Canvas Items
#

$cv create text 15 104 -tags "text dataSubscriberAsto-item1" -anchor nw \
          -text "Processed" \
          -fill black -font -Adobe-helvetica-medium-r-normal--12* 

$cv create text 28 60 -tags "text dataSubscriberAsto-item2" -anchor nw \
          -text "Queued" \
          -fill black -font -Adobe-helvetica-medium-r-normal--12* 


#
# Set Widget Configuration
#
set panWidget(dataSubscriberAsto-wdg1)  {UifButton 80.0 112.0 1 0 0 0 0 dataSubscriberAsto-wdg4Var 0 {}}
set panWidget(dataSubscriberAsto-wdg2)  {UifOutput -4.0 72.0 1 0 0 0 0 filesQueued 0 {} {}}
set panWidget(dataSubscriberAsto-wdg3)  {UifOutput -4.0 116.0 1 0 0 0 0 filesProcessed 0 {} {}}
set panWidget(dataSubscriberAstoBarchartWdg)  {UifBarChart -11.999999999999998 151.99999999999997 1 0 0 0 0 perc 0 0 {} {} 0 0}
set panWidget(dominoConfigWdg)  {UifButton 80.0 56.0 1 0 0 0 0 dataSubscriberAsto-wdg10Var 0 {}}
set panWidget(dominoNttWdg)  {UifBitmap 8.0 0.0 1 0 0 0 0 {} 0 get-file1.xbm}
set panWidget(dominoShowLogWdg)  {UifButton 80.0 84.0 1 0 0 0 0 dataSubscriberAsto-wdg11Var 0 {}}
set panWidget(dominoStartWdg)  {UifButton 80.0 4.440892099e-16 1 0 0 0 0 dataSubscriberAsto-wdg2Var 0 {}}
set panWidget(dominoStopWdg)  {UifButton 80.0 28.0 1 0 0 0 0 dataSubscriberAsto-wdg3Var 0 {}}
set panWidget(fromToWdg)  {UifOutput 0 199 1 0 0 0 0 fromToLabel 0 {} {}}

#
# Set Database Configuration
#

#
# Set Short Help for each widget
#

#
#-----------------------------------------------
#           Menu Bar Definition  
#-----------------------------------------------
# 

set menu(0) {File 1 file}


# Add MenuButton < File > 

set mb [addMenuButton $menuBar file " File " -1 left]

# Menu  

addMenuCmd $mb "Quit" 0 {dominoClose}

#
#-----------------------------------------------
#           Menu Help Definition  
#-----------------------------------------------
# 


#
#-----------------------------------------------
#            Create the Panel  
#-----------------------------------------------
#

wm geometry  $panRoot 176x266
wm title     $panRoot "ASTO DS"
set par(TITLE) "ASTO DS" 

panMainStart  dataSubscriberAsto $argc $argv

#--------------------    End of Main   --------------------



#####################################################
#           Definition of Local Procedures
#####################################################


proc dataSubscriberAstoExit {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}
