#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: dominoPrefsLibAsto.tcl,v 1.1 2004/09/06 14:47:14 cguirao Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# fsogni  30/01/98  created
#
#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc dominoPrefsInitX {} {
    global gvar env cv

    
    #bind $cv.dominoFromWdg.uifEntry <Any-KeyPress> {checkDate %K dominoFrom $cv.dominoFromWdg}
    #bind $cv.dominoToWdg.uifEntry <Any-KeyPress> {checkDate %K dominoTo $cv.dominoToWdg}

    set gvar(selectedTable) ""
}

proc dominoAcceptPrefs {} {
    global gvar cv
    
    if {![dominoCheckDate $gvar(dominoFrom) $gvar(dominoTo)]} {
	.dataSubscriberAsto.top.wdg.can.dominoStartWdg enable
	.dataSubscriberAsto.top.wdg.can.dominoStopWdg disable
	.dataSubscriberAsto.top.wdg.can.dominoNttWdg.frame.uifBitmap configure -background grey
	dominoPrefsClose
    } else { return }

}

proc dominoCheckDate {from to} { 
    global gvar 
    
    set currentDate [clock seconds]
   
    if {$to == "" && $from == ""} {
	Info "Please enter a date"
	return 1}
    
    if {$to != "" && $from == ""} {
	Info "Please fill in the From field."
	return 1}
    
    if {$from != ""} {
	if {[string length $from] < 10} {
	    Info "Error: The 'from' date has a wrong format.\nThe right format is: YYYY-MM-DD"
	    return 1}
	
	set fromDate [checkDateFormat $from]
	if {$fromDate == 0} {
	    Info "Error: The 'from' date is  not correct"
	    return 1}
	if {$fromDate > $currentDate} { Info "Error: The 'from' date is in the future"
	    return 1}
    }
    
    if {$to != ""} {
	if {[string length $to] < 10} {
	    Info "Error: The 'to' date has a wrong format.\nThe right format is: YYYY-MM-DD"
	    return 1}
	set toDate [checkDateFormat $to]
	if {$toDate == 0} {
	    Info "Error: The 'to' date is not correct"
	    return 1}
	if {$toDate > $currentDate} { Info "Error: The 'to' date is in the future"
	    return 1}
	
	if {$fromDate > $toDate} { Info "Error: The 'to' date must be after From:"
	    return 1}    
    }
    return 0
}


proc dominoCheckVariables {} {
    global gvar 


################# Perform checks on the  date ##########################    
    set currentDate [clock seconds]
    if {$gvar(dominoTo) != "" && $gvar(dominoFrom) == ""} {
	Info "Please fill in the From field."
	return 1}

    if {$gvar(dominoFrom) != ""} {
	set fromDate [checkDateFormat $gvar(dominoFrom)]
	if {$fromDate == 0} {
	    Info "Error: The 'from' date is  not correct."
	    return 1}
	if {$fromDate > $currentDate} { Info "Error: The 'from' date is in the future."
	    return 1}
    }
    
    if {$gvar(dominoTo) != ""} {
	set toDate [checkDateFormat $gvar(dominoTo)]
	if {$toDate == 0} {
	    Info "Error: The 'to' date is not correct."
	    return 1}
	if {$toDate > $currentDate} { Info "Error: The 'to' date  is in the
future."
	    return 1}

	if {$fromDate > $toDate} { Info "Error: The 'to' date must be after the 'from' date."
	    return 1}    
}
#################### End Check of Date ###################################

    return 0
}

proc checkDateFormat {date} {
    global gvar

    set splitDate [split $date "-"]
    set year [lindex $splitDate 0]
    set month [lindex $splitDate 1]
    set day [lindex $splitDate 2]

    if {[catch {set date [clock scan "$month/$day/$year"]}]} { return 0 
    } else { return $date}
}

proc checkDate {newKey var Wdg} {
    global gvar cv env
    
    #I do this to trap Delete and act like BackSpace
    if {[string compare $newKey "Delete"] == 0} {
		set gvar($var) [string range $gvar($var) 0 [expr  {[string length $gvar($var)] -2}]]
	return
    }
    
    if {[string compare $newKey "BackSpace"] == 0} { return }
    
    
    if {![string match {[0-9]} $newKey] && 
	![string match "minus" $newKey] } {
	if {$gvar($var) == "" } { 
	    after 15 "set gvar($var) {} "
	    set newKey ""
	} else { set newKey ""}
    }	
    
    if {$newKey == "minus"} {set newKey "-"}
    if {[string length $gvar($var)] == 10} {set newKey ""} 
    
    set tmpkey $gvar($var)$newKey
    update
    after 10 set gvar($var) $tmpkey	
    after 10 $Wdg.uifEntry icursor end
    
}


proc dominoPrefsClose {} {
    global gvar

    panClosePanel no .dominoPrefsAsto

}

proc dominoAstoCheckEnv {} {
    global gvar env
    
    if {$gvar(dominoFrom) != "" || $gvar(dominoTo) != ""} {
		if {![dominoCheckDate $gvar(dominoFrom) $gvar(dominoTo)]} {
			.dataSubscriberAsto.top.wdg.can.dominoStartWdg enable
			.dataSubscriberAsto.top.wdg.can.dominoStopWdg disable
			.dataSubscriberAsto.top.wdg.can.dominoNttWdg.frame.uifBitmap configure -background grey
		} else { explain }
    } elseif {[catch {set lastDate [file tail [lindex [lsort -decreasing [glob $env(DFS_BACKLOG)/*] ] 0 ]]}]} {
			set gvar(dominoFrom) ""
	} elseif {[checkDateFormat $lastDate] != "0"} {
		set splitDate [split $lastDate "-"]
		set numberDate [clock scan [lindex $splitDate 1]/[lindex $splitDate 2]/[lindex $splitDate 0]]
		set gvar(dominoFrom) [clock format [expr {$numberDate +86400 }] -format "%Y-%m-%d"]   
	} else { set gvar(dominoFrom) "" }
	#set gvar(dominoTo) ""
	#set currentDate "1998-04-16"
}

proc dominoDefaults {} {
    global gvar env 

    if {[file exists $env(ASTO_CONFIG_DIR)/dataSubscriberAsto.config]} {
	ScanConfigFile $env(ASTO_CONFIG_DIR)/dataSubscriberAsto.config gvar
    } else { Info "$env(ASTO_CONFIG_DIR)/dataSubscriberAsto.config doesn't exist. Exit"
	return }
    
    
    
    
    #set currentDate [clock format [clock seconds] -format "%Y-%m-%d"]
    set gvar(prefsList) "\
			    {dominoNoBacklog          {}}"
	 

    set savePrefs 0
    foreach el $gvar(prefsList) {
	set key [lindex $el 0]	
	if {![info exists gvar($key)]} {
	    set value [lindex $el 1]
	    set gvar($key) $value
	    set savePrefs 1	   
	}
    }

    #if {$savePrefs} {dominoSavePrefs}

}

proc dominoSavePrefs {} {
    global gvar env cv

    if {[dominoCheckVariables]} { return }

    set file [open $env(ASTO_CONFIG_DIR)/dataSubscriberAsto.config w]

    set fileBuf "\
	    ###########################################################\n\
	    #                                                         #\n\
	    #              THE ASTO ARCHIVE DATA SUBSCRIBER           #\n\
	    #                                                         #\n\
	    #              dataSubscriber Preferences                 #\n\
	    #                                                         #\n\
	    #              Don't edit this file manually.             #\n\
	    #                                                         #\n\
	    #              Edit it via the dataSubscriber.            #\n\
	    #                                                         #\n\
	    ###########################################################\n\n"
    set prefFormat "%-24s: %s\n"    
    foreach el $gvar(prefsList) {
	set key [lindex $el 0]	
	set value $gvar($key)
	set line [format $prefFormat $key $value]
	set fileBuf "${fileBuf}$line"
    }
    set fileBuf "${fileBuf}\n\n\# --- oOo ---\n"    
    puts $file $fileBuf
    close $file
}



#
# ___oOo___
