#!/bin/sh
# Define which version of the sequencer to use \
  exec seqWish "$0"  ${1+"$@"}
#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: dpDetails.pan,v 1.1 2004/09/06 14:47:14 cguirao Exp $" 
#
# dpDetails.pan
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 4.10+
#   date   : Wed Oct 28 18:22:12 MET 1998
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------
#
global par gvar cv bcv actAreaHeight shArea panClassLib 
global geoCmdReply panClassLib panUsrProcs panUsrLib
global argv0 env panWidget panWidgetHlp panDbData cwp ckHeartBeat
global menu menuBar menuHelp ckMenuBar ckActBut ckShHelp ckCCS
# 
#  Get directory root of VLT, integration, current module. 
global VLTROOT INTROOT HOME

if {[catch {set VLTROOT $env(VLTROOT)}]} {set VLTROOT dummy}
if {[catch {set INTROOT $env(INTROOT)}]} {set INTROOT dummy}
if {[catch {set HOME    $env(HOME)}   ]} {set HOME    dummy}
# 
# Set auto_path 
# 

if { [file exist ../lib/libpanPublic.tcl] } { 
   lappend auto_path ../lib/libpanPublic.tcl
} elseif { [file exist $INTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $INTROOT/lib/libpanPublic.tcl
} elseif { [file exist $VLTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $VLTROOT/lib/libpanPublic.tcl 
} else {
   puts stderr "panel EXITS : Tcl library libpanPublic.tcl not found " 
   exit 1
}

#
# Link panel to user libraries 
#
set panUsrLib   {libolasControlLib }  
set panClassLib {}

panSetAutoPath  $panUsrLib $panClassLib 

if {[info exists EDITING]} { 
   set panRoot .dpDetails 
   set panUsrProcs {dpDetailsInit dpDetailsExit dpDetailsInitData}
   set argc 0 ; set argv {}
} else {
   set par(MY_NAME) [file tail $argv0] 
   set EDITING 0
   set tk_strictMotif 0
   setPublicVar
   set panRoot . 
}

# User's Init Data : called just after panInit
# It contains data to be defined before widgets are created

proc dpDetailsInitData {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}



# User's Init Procedure : called in panMainStart
# It is executed after the widgets have been created

proc dpDetailsInit {} {

 # Declare global variables

   global cv

 # User Initialization
#return

[$cv.dpDetailsListWdg component uifFancyListBox] configure -font 9x15

   dpDetailsInitX
}



#
#-----------------------------------------------
#            Widget Definition  
#-----------------------------------------------
# 

set ckHeartBeat   0 ;# Enable Heart-beat
set ckShHelp      0 ;# Set Short Help
set ckActBut      0 ;# Set Action Button Area
set ckMenuBar     0 ;# Setup Menu Bar
set ckCCS         0 ;# Initialize CCS
set ckCmdReply    0 ;# Display Cmd. Reply
set cwp           "" ;# Set Current Working Point
set actAreaHeight 5; # Set height of action area 

panReadOption winter
set par(PANELX) 198 ;# Panel X position
set par(PANELY) 577 ;# Panel Y position
panCreateFrame dpDetails ;# Create empty frame
panGetCvNames  dpDetails cv bcv ;# Get Canvas Names
panInit        $argc $argv dpDetails ;# Initialization



UifButton          $cv.dpDetails-wdg1 -canvasAnchor nw \
                   -command dpDetailsClosePanel -initialState normal \
                   -label Close -popup 0 -stateVar gvar(dpDetails-wdg3Var) \
                   -width 20
UifOutput          $cv.dpDetails-wdg2 -anchor w -canvasAnchor nw \
                   -color Black -font -Adobe-courier-medium-r-normal--12* \
                   -frame 0 \
                   -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-* \
                   -labelWidth 0 -width 0
UifOutput          $cv.dpDetails-wdg3 -anchor w -canvasAnchor nw \
                   -color Black -font -Adobe-courier-medium-r-normal--14* \
                   -frame 0 \
                   -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-* \
                   -labelWidth 0 -variable gvar(dpDetailsHdr) -width 87
UifOutput          $cv.dpDetails-wdg4 -anchor w -canvasAnchor nw \
                   -color Black -font -Adobe-courier-medium-r-normal--14* \
                   -frame 0 -label {Data Product ID:} \
                   -labelFont -Adobe-helvetica-bold-r-normal--14* \
                   -labelWidth 0 -variable gvar(dpID) -width 35
UifFancyListBox    $cv.dpDetailsListWdg -activebackground Black \
                   -background Grey80 -borderwidth 2 \
                   -font -Adobe-helvetica-medium-r-normal--14* \
                   -geometry 87x5 -height 10 -initialState normal \
                   -relief sunken -scrollx 1 -scrolly 1 -selectmode single \
                   -wrap none

#
#  Canvas Items
#


#
# Set Widget Configuration
#
set panWidget(dpDetails-wdg1)  {UifButton 328.0 232.0 1 0 0 0 0 {} 0 {}}
set panWidget(dpDetails-wdg2)  {UifOutput 24 48 1 0 0 0 0 dpDetailsHdr 0 {} {}}
set panWidget(dpDetails-wdg3)  {UifOutput 4 28 1 0 0 0 0 dpDetailsHdr 0 {} {}}
set panWidget(dpDetails-wdg4)  {UifOutput 12 4 1 0 0 0 0 dpID 0 {} {}}
set panWidget(dpDetailsListWdg)  {PubClass 4 52 1 0 libolasControlLib.tcl nw 0 {} 0}

#
# Set Database Configuration
#

#
# Set Short Help for each widget
#

#
#-----------------------------------------------
#            Create the Panel  
#-----------------------------------------------
#

wm geometry  $panRoot 809x282
wm title     $panRoot "Data Product Details"
set par(TITLE) "Data Product Details" 

panMainStart  dpDetails $argc $argv

#--------------------    End of Main   --------------------



#####################################################
#           Definition of Local Procedures
#####################################################


proc dpDetailsExit {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}
