#!/bin/sh
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# COPYRIGHT (c) 1996 European Southern Observatory
# LICENSE
#
# PROJECT:   VLT Data Flow System
# AUTHOR:    Carlos Guirao - ESO/DMD/DPG
# CI NUMBER: DFS-SCR-001
#
# $Revision: 1.1 $
# $Log: createDiff.sh,v $
# Revision 1.1  2004/09/06 12:50:28  cguirao
# *** empty log message ***
#
# Revision 1.1  2004/09/02 14:17:12  cguirao
# First check in
#
# Revision 1.1  2004/06/24 11:24:56  cguirao
# First check-in
#
# Revision 1.3  2002/04/16 10:55:05  dataflow
# Adding binary and new files.CG
#
# Revision 1.2  2001/12/07 14:49:17  dataflow
# /bin/sh instead /sbin/sh. CG
#
# Revision 1.1  1998/06/29 09:14:05  dataflow
# createDiff -> createDiff.sh
#
#
#------------------------------------------------------------------------------

#
# Checking echo
#
echo=echo
if [ "`echo -n`" = "-n" ] ; then
    SV_NONL="\c"
else
    echo="echo -n"
fi

#
# At least three parameters are required: modified, original and the
# directory to dump modified files into.
#
if [ $# -lt  3 ]; then
  echo "Usage: createDiff.sh mod-dir orig-dir diff-dir"
  exit 1
fi

#
# Check if $3 exists
#
if [ -d $3 ]; then 
  $echo "createDiff.sh: $3 exits, overwrite it [yn]? (y): " $SV_NONL
  read answ
  if [ -z "$answ" ]; then
    answ=y
  fi
  if [ "$answ" = "y" -o "$answ" = "Y" ]
  then
    echo "rm -rf $3"
    rm -rf $3
  else
    echo "Bye then..."
    exit 1  
  fi
fi

rm -rf tmp-diff
mkdir tmp-diff

echo "diff $1 $2 > $3"
rm -f /tmp/list-diff
diff -r $1 $2 | egrep '^diff|^Binary' | egrep -v '.sniffdir' | gawk '{print $3}' > /tmp/list-diff

diff -r $1 $2 | egrep '^Only in '$2 | egrep -v '.sniffdir' | sed -e 's/Only in //' -e 's/: /\//' >> /tmp/list-diff

tar cf - `cat /tmp/list-diff` | (cd tmp-diff ; tar xf -)

mv tmp-diff/$1 $3
rmdir tmp-diff

echo "Done."

exit 0 
