#!/bin/bash 
#
# olasDfs.sh: starts/stops olas processes
#
# chkconfig: 2345 95 05
#
# description: Starts and stops the olas daemons
#
# processname: dhs, frameIngest, watchdog-FrameIngest, watchdog-DHS
#

# Source function library.

OWNER=XXXXXX

#
# Check the OWNER user exist 
#
id $OWNER > /dev/null
if [ $? -ne 0 ]; then  
  exit 1
fi

# Source function library.
. /etc/rc.d/init.d/functions 


RETVAL=0

start() {
        echo -n $"Starting olasDfs: "
	daemon --user $OWNER olasDhsControl start
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && touch /var/lock/subsys/olasDfs
        return $RETVAL
}

stop() {
        echo -n $"Shutting down olasDfs: "
	daemon --user $OWNER olasDhsControl stop
        RETVAL=$?
        echo
	[ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/olasDfs
        return $RETVAL
}


# See how we were called.
case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  status)
	status dhs
	status frameIngest
	status ngamsIngest
	status watchdog-DHS
	status watchdog-FrameIngest
	;;
  restart)
	stop
	start
	;;
  *)
	echo "Usage: $0 {start|stop|status|restart}"
	exit 1
esac

exit $RETVAL
