#!/bin/bash 
#
# pipelineDfs.sh: starts/stops pipeline processes
#
# chkconfig: 2345 94 06
#
# description: Starts and stops the pipeline daemons
#
# processname: vcsolac, dhsSubscribe, dhs, watchdog-DhsSubscribe, watchdog-DHS
#

# Source function library.

OWNER=XXXXXX

#
# Check the OWNER user exist 
#
id $OWNER > /dev/null
if [ $? -ne 0 ]; then  
  exit 1
fi

# Source function library.
. /etc/rc.d/init.d/functions 


RETVAL=0

start() {
        echo -n $"Starting pipelineDfs: "
	daemon --user $OWNER pipelineControl start
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && touch /var/lock/subsys/pipelineDfs
        return $RETVAL
}

stop() {
        echo -n $"Shutting down pipelineDfs: "
	daemon --user $OWNER pipelineControl stop
        RETVAL=$?
        echo
	[ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/pipelineDfs
        return $RETVAL
}


# See how we were called.
case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  status)
	status dhs
	status dhsSubscribe
	status vcsolac
	status watchdog-DHS
	status watchdog-DhsSubscribe
	;;
  restart)
	stop
	start
	;;
  *)
	echo "Usage: $0 {start|stop|status|restart}"
	exit 1
esac

exit $RETVAL
