package org.eso.gasgano.tools;

/**
 * @author nkornwei
 *
 * Program Id tools
 */
public class ProgId {

    /**
     * unfortunately since obrep2 the program Id is stored in a 
     * numeric way
     * This is merely the conversion routine, still to be completed
     *
     * @author: Michele Zamparelli
     */

    public static String convertProgId(String progId) {
        String rc = null;
        try {
            int dotIndex = progId.indexOf('.');
            int braceIndex = progId.indexOf('(');
            int subpanel = progId.charAt(braceIndex + 1) - 65;

            String start = progId.substring(0, dotIndex);
            String proposalId = progId.substring(dotIndex + 3, dotIndex + 7);

            rc =
                new String(start + proposalId + "0" + String.valueOf(subpanel));
        } catch (StringIndexOutOfBoundsException siobe) {
            // System.err.println("Malformed Prog ID "+progId);
            rc = new String("00000");
        }
        return rc;
    }

    /**
     * @params: fullName = 65.O-0321(A), numericName = 6503210
     * @returns: true if matching
     *
     */
    public static boolean matchNumericProgId(
        String fullName,
        String numericName) {
        if (convertProgId(fullName).equals(numericName)) {
            return true;
        }
        return false;
    }



}
