package org.eso.ohs.core.utilities;

import java.io.IOException;


/**
 * Utility class to encrypt a PAF file.<BR>
 * Usage:<BR>
 * <tt>
 * &nbsp;&nbsp;&nbsp;&nbsp;java EncryptPafFile inputfile outputfile<BR>
 * </tt>
 * @author ???
 * @version $Revision: 1.1 $
 */

public class EncryptPafFile {

    /** Name of this class */
    private static final String classname_ = EncryptPafFile.class.getName();

    public static void encryptPafFile( String infile, String outfile )
    throws IOException {
         
        PafFile paf      = new PafFile( infile );
        PafData[] idList = paf.getIdentifierList();
    
        for( int i=0; i<idList.length; i++ ) {
            if( idList[i].getIdentifier().startsWith( "ENCRYPTED" )) {
                String s = Encrypt.encrypt(idList[i].getValue());
                idList[i].setValue(s);
            }
        }
    
        PafFile out = new PafFile( outfile, true );
        for( int i=0; i<idList.length; i++ ) 
            out.writeLine( idList[i].getIdentifier() + 
                   "\t\"" + 
                   idList[i].getValue() + 
                   "\"" );
         
        out.closeWriter();
         
    }

    public static void main(String [] args) {
        if (args.length != 2) {
            System.err.println( "Usage: java " + classname_ + " inf outf" );
            System.exit(1);
        }
        
        try {
            encryptPafFile( args[0], args[1] );
        }
        catch(IOException e) {
    
            e.printStackTrace();
            System.err.println( classname_ + ": fatal I/O error" );
            System.exit(1);
        }
    }
}
