/*
 * Created on 11.11.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.eso.ohs.instruments;

import java.util.StringTokenizer;

/**
 * @author tcanavan
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ReadmeKeywordList extends ReadmeAttribute {

    private static final long serialVersionUID = -4378250031958131801L;

    public static final String DB_TYPE = "K";

    /**
     * @param readmeConfig
     */
    public ReadmeKeywordList(InstrumentConstraintConfig readmeConfig) {
        super(readmeConfig);
        // TODO Auto-generated constructor stub
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.instruments.ReadmeAttribute#isComplete()
     */
    public boolean isCompulsory() {
        // TODO Auto-generated method stub
        InstrumentConstraintConfig conf = getReadmeConfig();
        String value = getValue();
        if (conf.isCompulsory()) {
            if (!hasValue()) {
                return false;
            }
        }
        return true;
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.instruments.ReadmeAttribute#getRawValue()
     */
    public Object getRawValue() {
        // TODO Auto-generated method stub
        return getValue();
    }
    public String [] getValueAsArray() {
        String [] strArray;
        if (hasValue()) {
            StringTokenizer tok =
                new StringTokenizer(getValue(), ":");
            strArray = new String[tok.countTokens()];
            int i = 0;
            while (tok.hasMoreTokens()) {
                strArray[i] = tok.nextToken();
                i++;
            }
        } else {
            strArray = new String[0];
        }
        return strArray;
        
    }

    public String verify() {
        String value = getValue();
        InstrumentConstraintMetaData meta = getReadmeConfig().getMetaData();
        String[] allowedValues = meta.getAllowedValues();
        if (!isCompulsory())
            return ReadmeAttribute.VERIFY_EMPTY;
        String [] strArray = getValueAsArray();    
        for (int i = 0; i < strArray.length; i++) {
            boolean found = false;
            for(int j=0;j<allowedValues.length;j++) {
                if (strArray[i].equals(allowedValues[j])) {
                    found = true;
                    break;
                }
                
            }
            if (!found)
                return "INVALID";
        }
        return "OK";
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.instruments.ReadmeAttribute#getDBType()
     */
    public static String getDBType() {
        // TODO Auto-generated method stub
        return DB_TYPE;
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.instruments.ReadmeAttribute#getToolTipText()
     */
    public String getToolTipText() {
        InstrumentConstraintConfig conf = getReadmeConfig();
        InstrumentConstraintMetaData metaData = conf.getMetaData();
        InstrumentConstraintMetaData meta = getReadmeConfig().getMetaData();
        String[] allowedValues = meta.getAllowedValues();
        StringBuffer buf = new StringBuffer();
        for (int i = 0; i < allowedValues.length; i++) {
            buf.append(allowedValues[i]);
            if (i >= 0 && i < allowedValues.length - 1)
                buf.append(":");
        }
        buf.toString();
        String tooltip = "Enter value from list:- " + buf.toString();
        return tooltip;
    }
}
