/*
 * Created on Jul 1, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.eso.ohs.persistence.dbase.phase2;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Vector;

import org.eso.ohs.core.utilities.ConnectionPool;
import org.eso.ohs.core.utilities.SqlUtils;
import org.eso.ohs.dfs.BusinessObject;
import org.eso.ohs.dfs.ConstraintSet;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.instruments.Instrument;
import org.eso.ohs.instruments.InstrumentConstraintConfig;
import org.eso.ohs.instruments.InstrumentList;
import org.eso.ohs.persistence.Config;

/**
 * @author tcanavan
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ProcessExtraConstraints {

    private static HashMap compulsoryConstraints = new HashMap();
    static {
        compulsoryConstraints.put("Airmass", "Airmass");
        compulsoryConstraints.put("Seeing", "Seeing");
        compulsoryConstraints.put("SkyTransparency", "SkyTransparency");
        compulsoryConstraints.put(
            "FractionalLunarIllumination",
            "FractionalLunarIllumimation");
        compulsoryConstraints.put("MoonAngularDistance", "MoonAngularDistance");
        compulsoryConstraints.put("StrehlRatio", "StrehlRatio");
    }

    private static String obrepDbName =
        Config.getCfg().getDbName(ObservationBlock.getSuffix());

    public static String[] getBaseLines() throws SQLException {
        Config cfg = Config.getCfg();
        String suffix = BusinessObject.getSuffix(ObservationBlock.class);
        String url = cfg.getUrl(suffix);
        String user = cfg.getDbUserName();
        String pwd = cfg.getDbPassword();
        Vector vec = new Vector();
        Connection con =
            ConnectionPool.getPool().acquireConnection(url, user, pwd);
        Statement stmt = con.createStatement();
        String sql = "SELECT baseline_name from " + obrepDbName + "..baselines";
        ResultSet rs = stmt.executeQuery(sql);
        while (rs.next()) {
            vec.addElement(rs.getString("baseline_name").trim());
        }
        String[] baselines = new String[vec.size()];
        vec.copyInto(baselines);
        ConnectionPool.getPool().releaseConnection(con);
        return baselines;
    }

    public static void write(
        Statement stmt,
        ConstraintSet cs,
        String instCode,
        float ipVersion,
        long id)
        throws SQLException {
        if (instCode != null) {
            Instrument instObject =
                InstrumentList.getInstance().getInstrument(instCode, ipVersion);
            InstrumentConstraintConfig[] instConfList =
                instObject.getCsConfList();
            for (int i = 0; i < instConfList.length; i++) {
                if (!compulsoryConstraints
                    .containsKey(instConfList[i].getName())) {
                    Class cls = cs.getClass();
                    Method get;
                    try {
                        get =
                            cls
                                .getMethod(
                                    "get" + instConfList[i].getName(),
                                    new Class[] {
                        });
                        Object obje = get.invoke(cs, new Object[] {
                        });
                        if (instConfList[i].hasFCConstraint()) {
                            insertFKConstraint(
                                stmt,
                                id,
                                instConfList[i].getMetaData().getBaseType(),
                                instConfList[i].getFkColumn(),
                                instConfList[i].getFkTable(),
                                instConfList[i].getDbColumn(),
                                obje.toString());
                        } else {
                            updateColumn(
                                stmt,
                                id,
                                instConfList[i].getMetaData().getBaseType(),
                                instConfList[i].getDbColumn(),
                                obje.toString());                            
                        }

                    } catch (SecurityException e) {
                        throw new SQLException(e.getMessage());
                    } catch (NoSuchMethodException e) {
                        throw new SQLException(e.getMessage());
                    } catch (IllegalArgumentException e) {
                        throw new SQLException(e.getMessage());
                    } catch (IllegalAccessException e) {
                        throw new SQLException(e.getMessage());
                    } catch (InvocationTargetException e) {
                        throw new SQLException(e.getMessage());
                    }
                }
            }
        }
    }

    private static String readFKConstraint(
        Statement stmt,
        long id,
        String type,
        String foreignKey,
        String foreignTableName,
        String column)
        throws SQLException {
        String sql =
            "SELECT "
                + column
                + " from "
                + obrepDbName + ".."
                + foreignTableName + ","
                + obrepDbName + ".."                
                + "constraint_sets"
                + " where "
                + obrepDbName + ".." + foreignTableName
                + "."
                + foreignKey
                + " = " + obrepDbName + ".." + "constraint_sets."
                + foreignKey
                + " AND " + obrepDbName + ".." + "constraint_sets.cs_id = "
                + id;
        ResultSet rs = stmt.executeQuery(sql);
        String name = null;
        while (rs.next()) {
            name = getValue(type, rs, name);
        }
        return name;
    }

    private static String readColumn(
        Statement stmt,
        long id,
        String type,
        String column)
        throws SQLException {
        String sql =
            "SELECT "
                + column
                + " from "
                + " constraint_sets"
                + " where "
                + " constraint_sets.cs_id = "
                + id;
        ResultSet rs = stmt.executeQuery(sql);
        String name = null;
        while (rs.next()) {
            name = getValue(type, rs, name);
        }
        return name;
    }

    private static String getValue(String type, ResultSet rs, String name)
        throws SQLException {
        if (type.equals("string")) {
            name = rs.getString(1);
        } else if (type.equals("integer")) {
            name = new Integer(rs.getInt(1)).toString();
        } else if (type.equals("float")) {
            name = new Float(rs.getInt(1)).toString();
        }
        return name;
    }

    public static void read(Statement stmt, long id, ConstraintSet cs)
        throws SQLException {
        String instCode = InstrumentPackageDBIO.getInstFromOd(stmt, id);
        float ipVersion = InstrumentPackageDBIO.getIPVFromOd(stmt, id);
        if (instCode != null) {
            Instrument instObject =
                InstrumentList.getInstance().getInstrument(instCode, ipVersion);
            InstrumentConstraintConfig[] instConfList =
                instObject.getCsConfList();
            for (int i = 0; i < instConfList.length; i++) {
                if (!compulsoryConstraints
                    .containsKey(instConfList[i].getName())) {
                    Class cls = cs.getClass();
                    Method set;
                    try {
                        set =
                            cls.getMethod(
                                "set" + instConfList[i].getName(),
                                new Class[] { String.class });
                        if (instConfList[i].hasFCConstraint()) {
                            String value =
                                readFKConstraint(
                                    stmt,
                                    id,
                                    instConfList[i].getMetaData().getBaseType(),
                                    instConfList[i].getFkColumn(),
                                    instConfList[i].getFkTable(),
                                    instConfList[i].getDbColumn());
                            if(value != null) {
                                set.invoke(cs, new Object[] { value.trim()});                                        
                            } else {
                                set.invoke(cs, new Object[] {instConfList[i].getMetaData().getDefaultValue()});                                
                            }
                        } else {
                            String value =
                                readColumn(
                                    stmt,
                                    id,
                                    instConfList[i].getMetaData().getBaseType(),
                                    instConfList[i].getDbColumn());
                            set.invoke(cs, new Object[] { value.trim()});
                        }
                    } catch (SecurityException e) {
                        throw new SQLException(e.getMessage());
                    } catch (NoSuchMethodException e) {
                        throw new SQLException(e.getMessage());
                    } catch (IllegalArgumentException e) {
                        throw new SQLException(e.getMessage());
                    } catch (IllegalAccessException e) {
                        throw new SQLException(e.getMessage());
                    } catch (InvocationTargetException e) {
                        throw new SQLException(e.getMessage());
                    }
                }
            }
        }
    }

    public static void update(Statement stmt, long id, ConstraintSet cs)
        throws SQLException {
        String instCode = InstrumentPackageDBIO.getInstFromOd(stmt, id);
        float ipVersion = InstrumentPackageDBIO.getIPVFromOd(stmt, id);
        if (instCode != null) {
            Instrument instObject =
                InstrumentList.getInstance().getInstrument(instCode, ipVersion);
            InstrumentConstraintConfig[] instConfList =
                instObject.getCsConfList();
            for (int i = 0; i < instConfList.length; i++) {
                if (!compulsoryConstraints
                    .containsKey(instConfList[i].getName())) {
                    Class cls = cs.getClass();
                    Method get;
                    try {
                        get =
                            cls
                                .getMethod(
                                    "get" + instConfList[i].getName(),
                                    new Class[] {
                        });
                        Object obje = get.invoke(cs, new Object[] {
                        });
                        if (instConfList[i].hasFCConstraint()) {
                            updateFKConstraint(
                                stmt,
                                id,
                                instConfList[i].getMetaData().getBaseType(),
                                instConfList[i].getFkColumn(),
                                instConfList[i].getFkTable(),
                                instConfList[i].getDbColumn(),
                                obje.toString().trim());

                        } else {
                            updateColumn(
                                stmt,
                                id,
                                instConfList[i].getMetaData().getBaseType(),
                                instConfList[i].getDbColumn(),
                                obje.toString());
                        }
                    } catch (SecurityException e) {
                        e.printStackTrace();
                        throw new SQLException(e.getMessage());
                    } catch (NoSuchMethodException e) {
                        e.printStackTrace();
                        throw new SQLException(e.getMessage());
                    } catch (IllegalArgumentException e) {
                        e.printStackTrace();
                        throw new SQLException(e.getMessage());
                    } catch (IllegalAccessException e) {
                        e.printStackTrace();
                        throw new SQLException(e.getMessage());
                    } catch (InvocationTargetException e) {
                        e.printStackTrace();
                        throw new SQLException(e.getMessage());
                    }
                }
            }
        }
    }

    private static void insertFKConstraint(
        Statement stmt,
        long id,
        String type,
        String foreignKey,
        String foreignTableName,
        String column,
        String value)
        throws SQLException {
        boolean exists = false;
        long foreignId = -1;
        String sql = null;
        if (type.equals("string")) {
            sql =
                "SELECT * from "
                    + foreignTableName
                    + " where "
                    + column
                    + " = "
                    + SqlUtils.sqlEscapedString(value);

        } else {
            sql =
                "SELECT * from "
                    + foreignTableName
                    + " where "
                    + column
                    + " = "
                    + value;
        }

        ResultSet rs = stmt.executeQuery(sql);
        while (rs.next()) {
            foreignId = rs.getLong(foreignKey);
        }

        if (foreignId == -1) {
            foreignId = id;
            if (type.equals("string")) {
                sql =
                    "INSERT INTO "
                        + foreignTableName
                        + " ("
                        + foreignKey
                        + ","
                        + column
                        + ")"
                        + " VALUES ("
                        + id
                        + ","
                        + SqlUtils.sqlEscapedString(value)
                        + ")";
                stmt.execute(sql);
            } else {
                sql =
                    "INSERT INTO "
                        + foreignTableName
                        + " ("
                        + foreignKey
                        + ","
                        + column
                        + ")"
                        + " VALUES ("
                        + id
                        + ","
                        + value
                        + ")";
                stmt.execute(sql);
            }

        }
        sql =
            "update constraint_sets set "
                + foreignKey
                + " = "
                + foreignId
                + " WHERE cs_id = "
                + id;
        stmt.executeUpdate(sql);
    }

    private static void updateColumn(
        Statement stmt,
        long id,
        String type,
        String column,
        String value)
        throws SQLException {
        String sql = null;
        if (type.equals("string")) {
            sql =
                "UPDATE constraint_sets set ("
                    + column
                    + ")"
                    + " VALUES ("
                    + SqlUtils.sqlEscapedString(value)
                    + ")";
            stmt.execute(sql);
        } else {
            sql =
                "UPDATE constraint_sets set ("
                    + column
                    + ")"
                    + " VALUES ("
                    + value
                    + ")";

            stmt.execute(sql);
        }
    }

    private static void updateFKConstraint(
        Statement stmt,
        long id,
        String type,
        String foreignKey,
        String foreignTableName,
        String column,
        String value)
        throws SQLException {
        boolean exists = false;
        long foreignId = -1;
        String sql = null;
        if (type.equals("string")) {
            sql =
                "SELECT * from "
                    + foreignTableName
                    + " where "
                    + column
                    + " = "
                    + SqlUtils.sqlEscapedString(value);
        } else {
            sql =
                "SELECT * from "
                    + foreignTableName
                    + " where "
                    + column
                    + " = "
                    + value;

        }
        ResultSet rs = stmt.executeQuery(sql);
        while (rs.next()) {
            foreignId = rs.getLong(foreignKey);
        }
        if (foreignId != -1) {
            sql =
                "update constraint_sets set "
                    + foreignKey
                    + " = "
                    + foreignId
                    + " WHERE cs_id = "
                    + id;
            stmt.execute(sql);
        }
    }
}
