package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;

import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;

import com.jeta.forms.components.image.ImageComponent;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

public class WizardTitlePanel {
    
        /**
         * Adds fill components to empty cells in the first row and first column of
         * the grid. This ensures that the grid spacing will be the same as shown in
         * the designer.
         * 
         * @param cols
         *            an array of column indices in the first row where fill
         *            components should be added.
         * @param rows
         *            an array of row indices in the first column where fill
         *            components should be added.
         */
        void addFillComponents(Container panel, int[] cols, int[] rows) {
            Dimension filler = new Dimension(10, 10);

            boolean filled_cell_11 = false;
            CellConstraints cc = new CellConstraints();
            if (cols.length > 0 && rows.length > 0) {
                if (cols[0] == 1 && rows[0] == 1) {
                    /** add a rigid area */
                    panel.add(Box.createRigidArea(filler), cc.xy(1, 1));
                    filled_cell_11 = true;
                }
            }

            for (int index = 0; index < cols.length; index++) {
                if (cols[index] == 1 && filled_cell_11) {
                    continue;
                }
                panel.add(Box.createRigidArea(filler), cc.xy(cols[index], 1));
            }

            for (int index = 0; index < rows.length; index++) {
                if (rows[index] == 1 && filled_cell_11) {
                    continue;
                }
                panel.add(Box.createRigidArea(filler), cc.xy(1, rows[index]));
            }

        }


    public static JPanel createPanel()
    {
        WizardTitlePanel title = new WizardTitlePanel();
        JLabel labelTitle = new JLabel();
        ImageComponent orange = new ImageComponent(); 
 
       JPanel jpanel1 = new JPanel();
       FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
       CellConstraints cc = new CellConstraints();
       jpanel1.setLayout(formlayout1);
       
       orange.setIcon(title.loadImage("orangeSmall.gif"));
       orange.setName("orange");
       jpanel1.add(orange,cc.xy(2,1));

       labelTitle.setBackground(new Color(255,255,255));
       labelTitle.setFont(new Font("sansserif",Font.BOLD,18));
       labelTitle.setName("labelTitle");
       labelTitle.setText("ORANG Wizard");
       jpanel1.add(labelTitle,cc.xywh(4,1,12,1));

       title.addFillComponents(jpanel1,new int[]{ 1,3,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21 },new int[]{ 1,2 });
       jpanel1.setOpaque(true);
       jpanel1.setBackground(Color.WHITE);
      
       return jpanel1;
    }

    /**
     * Helper method to load an image file from the CLASSPATH
     * 
     * @param imageName
     *            the package and name of the file to load relative to the
     *            CLASSPATH
     * @return an ImageIcon instance with the specified image file
     * @throws IllegalArgumentException
     *             if the image resource cannot be loaded.
     */
    public ImageIcon loadImage(String imageName) {
        String imagePath = "org/eso/ohs/icons/"+imageName;
        try {
       
            ClassLoader classloader = getClass().getClassLoader();
            java.net.URL url = classloader.getResource(imagePath);
            if (url != null) {
                ImageIcon icon = new ImageIcon(url);
                return icon;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        throw new IllegalArgumentException("Unable to load image: " + imagePath);
    }
    
    public WizardTitlePanel() {
        super();
    }

}
